NPCs = {
	-- GUIDE
	[1] = {"Smith", pos={12*32+16,27*32+16}, rot=0, image=""}, 

	[2] = {"Jack", pos={16*32+16,12*32+16}, rot=0, image=""}, 
	
	[3] = {"Ihlo", pos={5*32+16,14*32+16}, rot=0, image=""}, 
	
	[4] = {"Mahn", pos={13*32+16,20*32+16}, rot=0, image=""}, 
	
	[5] = {"Sudt", pos={7*32+16,22*32+16}, rot=0, image=""}, 
	
	[6] = {"Hahn", pos={116*32+16,40*32+16}, rot=0, 
	trade={{252,1123},{253,1492},{-252,112},{-253,149}},
	greet="I've heard of a staff that fires bagels.", bye="I've heard premium members can get that staff.", image=""}, 
	
	[7] = {"Peet", pos={122*32+16,45*32+16}, rot=0, 
	trade={{456,20},{457,33},{-456,2},{-457,3}},
	greet="You'll be needing a lot of mana for those staffs!", bye="You'll be back..", image=""}, 
	
	[8] = {"Naes", pos={111*32+16,46*32+16}, rot=0, 
	trade={{452,18},{453,29},{-452,1},{-453,2}},
	greet="No weed, just potions.", bye="I've been clean for 10 years.", image=""}, 
	
	[9] = {"Officer", pos={125*32+16,109*32+16}, rot=0, image=""}, 
	
	[10] = {"Dave", pos={13*32+16,9*32+16}, rot=0, 
	trade={{-552,8},{-25,138},{-26,120},{-27,129},{-28,119}},
	greet="B-B-B-BONNNEESS!!", bye="Bone is the word.", image=""}, 

}

NPCs[1].func = function(npc, id, words, state)
	if words == "hi" then
		NPCspeak(npc, "Hello. Welcome to Alkania. This is the underworld of Aurora.")
		NPCspeak(npc, "Basically, you can do everything here just like Aurora.")
		NPCspeak(npc, "And when you want to go back, just go through the teleport!")
		PLAYERS[id].tmp.npcstate = nil
	end
end
NPCs[2].func = function(npc, id, words, state)
	if words == "hi" then
		NPCspeak(npc, "Would you like to rest in the Inn? (20 Gold)")
		PLAYERS[id].tmp.npcstate = {npc, 1}
	elseif contains(words, "bye") then
		NPCspeak(npc, "Goodbye.")
		PLAYERS[id].tmp.npcstate = nil
	elseif state == 1 then
		if contains(words, "yes") or contains(words, "ok") or contains(words, "sure") then
			if addmoney(id, -20) then
				NPCspeak(npc, "Have a nice stay.")
				parse("setpos " .. id .. " "..(14*32+16).." "..(14*32+16))
				PLAYERS[id].tmp.npcstate = nil
			else
				NPCspeak(npc,"You don't have enough Gold.")
			end
		elseif contains(words, "no") then
			NPCspeak(npc, "That's fine, bye.")
			PLAYERS[id].tmp.npcstate = nil
		end
	end
end
NPCs[3].func = function(npc, id, words, state)
	if words == "hi" then
		NPCspeak(npc, "Hey! You! I need bones. I'll trade them for something special.")
		NPCspeak(npc, "So, you gonna give them suckers or what!?")
		PLAYERS[id].tmp.npcstate = {npc, 1}
	elseif contains(words, "bye") then
		NPCspeak(npc, "Your loss..")
		PLAYERS[id].tmp.npcstate = nil
	elseif state == 1 then
		if contains(words, "yes") or contains(words, "ok") or contains(words, "sure") then
			for b = 1, 50 do
				if removeitem(id,552) then
					PLAYERS[id].bones = PLAYERS[id].bones + 1
					if PLAYERS[id].bones == 100 then
						NPCspeak(npc, "Thanks kid, 100 bones. Here's the special gift I promised.")
						additem(id,25)
						additem(id,26)
						additem(id,27)
						additem(id,28)
						msg2(id,"\169255255150[ITEM]:\169255255255 Received: Skeleton Helmet.")
						msg2(id,"\169255255150[ITEM]:\169255255255 Received: Skeleton Torso.")
						msg2(id,"\169255255150[ITEM]:\169255255255 Received: pair of Skeleton Legs.")
						msg2(id,"\169255255150[ITEM]:\169255255255 Received: pair of Skeleton Boots.")
						PLAYERS[id].bones = 0
						break
					end
				else
					NPCspeak(npc,"You don't have any more bones!")
					break
				end
			end
			NPCspeak(npc, (100-PLAYERS[id].bones).." left until unique armour.")
		end
	end
end
NPCs[4].func = function(npc, id, words, state)
    if words == "hi" then
        if not PLAYERS[id].q5 then
            PLAYERS[id].q5 = 0
            PLAYERS[id].q5m = 0
            NPCspeak(npc, "Hey. You look strong! Can you do something for me?")
            PLAYERS[id].tmp.npcstate = {npc, 1}
        end
        if PLAYERS[id].q5 == 1 then
            NPCspeak(npc, "Have you killed them yet? I guess not.")
            PLAYERS[id].tmp.npcstate = nil
        elseif PLAYERS[id].q5 == 2 then
            NPCspeak(npc, "Oh my! Thank you so much! Here, this belonged to my father.")
			additem(id,208)
			msg2(id,"\169255255150[ITEM]:\169255255255 Received: Skeleton Crossbow.")
            PLAYERS[id].q5 = 3
            PLAYERS[id].tmp.npcstate = nil
        end
    elseif contains(words, "bye") then
        NPCspeak(npc, "Please! I need you!")
        PLAYERS[id].tmp.npcstate = nil
    elseif state == 1 then
        if contains(words, "yes") or contains(words, "ok") or contains(words, "sure") then
            NPCspeak(npc, "Kill 100 Skeletons for me. I can offer a weapon in return.")
            hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Find and kill 100 Skeletons.', '255255255',320,391,1)
            timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
            PLAYERS[id].q5 = 1
        elseif contains(words, "no") then
            NPCspeak(npc, "Please! I need you!")
            PLAYERS[id].tmp.npcstate = nil
        end
    end
end
NPCs[5].func = function(npc, id, words, state)
    if words == "hi" then
        NPCspeak(npc, "Hey there, I'm your local banker.")
        NPCspeak(npc, "What do you want to do: take, deposit or check your rate?")
        PLAYERS[id].tmp.npcstate = {npc, 1}
    elseif contains(words, "bye") then
        NPCspeak(npc, "Come back any time. But don't expect interest.")
        PLAYERS[id].tmp.npcstate = nil
    elseif state == 1 then
        if contains(words, "take") then
            NPCspeak(npc, "Okay, just type the amount you want to take out.")
            PLAYERS[id].tmp.npcstate = {npc, 2}
        elseif contains(words, "deposit") then
            NPCspeak(npc, "Okay, just type the amount you want to deposit.")
            PLAYERS[id].tmp.npcstate = {npc, 3}
        elseif contains(words, "check") or contains(words, "rate") then
            NPCspeak(npc, "Your bank account states you own "..PLAYERS[id].Bank.." Gold.")
            PLAYERS[id].tmp.npcstate = {npc, 4}
        elseif contains(words, "bye") then
            NPCspeak(npc, "Come back any time. But don't expect interest.")
            PLAYERS[id].tmp.npcstate = nil
        end
    elseif state == 2 then
        if contains(words,"inf") then
            NPCspeak(npc, "That won't work pal. Try again.")
        elseif contains(words,"nil") or contains(words,"nul") or contains(words,"nan") or contains(words,"-nan") then
            NPCspeak(npc, "That won't work pal. Try again.")
        elseif contains(words,"all") or contains(words,"everything") then
            if PLAYERS[id].Bank > 0 then
                NPCspeak(npc, "You have successfully taken out "..PLAYERS[id].Bank.." Gold.")
                addmoney(id,PLAYERS[id].Bank)
                PLAYERS[id].Bank = 0
            else
                NPCspeak(npc, "You have no Gold in your bank. Try again.")
            end
        elseif PLAYERS[id].Bank >= tonumber(words) then
            amount = math.floor(tonumber(words))
            if amount > 0 then
                NPCspeak(npc, "You have successfully taken out "..amount.." Gold.")
                PLAYERS[id].Bank = PLAYERS[id].Bank - amount
                addmoney(id,amount)
            else
                NPCspeak(npc, "That won't work pal. Try again.")
            end
        elseif PLAYERS[id].Bank < tonumber(words) then
            NPCspeak(npc, "You don't have enough in your bank!")
        end
        NPCspeak(npc, "Come back any time. But don't expect interest.")
        PLAYERS[id].tmp.npcstate = nil
    elseif state == 3 then
        if contains(words,"inf") then
            NPCspeak(npc, "That won't work pal. Try again.")
        elseif contains(words,"nil") or contains(words,"nul") or contains(words,"nan") or contains(words,"-nan") then
            NPCspeak(npc, "That won't work pal. Try again.")
        elseif contains(words,"all") or contains(words,"everything") then
            if PLAYERS[id].Gold > 0 then
                NPCspeak(npc, "You have successfully deposited "..PLAYERS[id].Gold.." Gold.")
                PLAYERS[id].Bank = PLAYERS[id].Bank + PLAYERS[id].Gold
                PLAYERS[id].Gold = 0
            else
                NPCspeak(npc, "You have no Gold!")
            end
        elseif tonumber(words) <= PLAYERS[id].Gold then
            amount = math.floor(tonumber(words))
            if amount > 0 then
                NPCspeak(npc, "You have successfully deposited "..amount.." Gold.")
                PLAYERS[id].Bank = PLAYERS[id].Bank + amount
                addmoney(id,-amount)
            else
                NPCspeak(npc, "That won't work pal. Try again.")
            end
        elseif tonumber(words) > PLAYERS[id].Gold then
            NPCspeak(npc, "You don't have enough Gold.")
        elseif tonumber(words) <= 0 then
            NPCspeak(npc, "That won't work pal. Try again.")
        end
        NPCspeak(npc, "Come back any time. But don't expect interest.")
        PLAYERS[id].tmp.npcstate = nil
    elseif state == 4 then
        if contains(words,"ok") or contains(words,"bye") or contains(words,"thanks") then
            NPCspeak(npc, "Come back any time. But don't expect interest.")
            PLAYERS[id].tmp.npcstate = nil
        end
    end
end
NPCs[9].func = function(npc, id, words, state)
    if words == "hi" then
        if PLAYERS[id].Prison == 0 then
            NPCspeak(npc, "How did you get here?")
            local spawn = PLAYERS[id].Spawn[1] .. " " .. PLAYERS[id].Spawn[2]
            parse("setpos "..id.." "..spawn)
            PLAYERS[id].tmp.npcstate = nil
        else
            if PLAYERS[id].Prisonfee > 0 then
                NPCspeak(npc, "You have been charged for: "..PLAYERS[id].Prisoncrime..".")
                NPCspeak(npc, "Lucky for you you can pay "..PLAYERS[id].Prisonfee.." to be released.")
                NPCspeak(npc, "Are you going to cough up or what?")
                PLAYERS[id].tmp.npcstate = {npc, 1}
            else
                NPCspeak(npc, "You have been charged for: "..PLAYERS[id].Prisoncrime..".")
                NPCspeak(npc, "Sadly for you no fee has been set. So you will have to wait.")
                PLAYERS[id].tmp.npcstate = nil
            end
        end
    elseif contains(words, "bye") then
        NPCspeak(npc, "Hah, you're not going anywhere soon so I'll see you around.")
        PLAYERS[id].tmp.npcstate = nil
    elseif state == 1 then
        if contains(words, "yes") or contains(words,"ok") or contains(words,"sure") or contains(words,"fine") then
            if addmoney(id,-PLAYERS[id].Prisonfee) then
                NPCspeak(npc, "Hm. Very well.")
                PLAYERS[id].Prison = 1
                PLAYERS[id].Prisonfee = 0
                PLAYERS[id].Prisoncrime = 0
            else
                NPCspeak(npc, "Not enough gold. Better luck next time.")
            end
        elseif contains(words, "no") then
            NPCspeak(npc, "I'll be here if you change your mind.")
            PLAYERS[id].tmp.npcstate = nil
        end
    end
end

for i, j in ipairs(NPCs) do
	if j.image ~= "" then
		j.shadow = image("gfx/yates/rpg/npc_villager.png", 0, 0, 0)
		j.image = image("gfx/yates/rpg/" .. (j.image or "npc_villager") .. ".png", 0, 0, 0)
		imagepos(j.image, j.pos[1], j.pos[2], j.rot)
		imagepos(j.shadow, j.pos[1]+2, j.pos[2]+2, j.rot)
		imagecolor(j.shadow, 0, 0, 0)
		imagealpha(j.shadow, 0.5)
	end
	if j.trade then
		local text = j[1] .. "@b,"
		for k, l in ipairs(j.trade) do
			local itemid
			if l[1] < 0 then
				itemid = -l[1]
				text = text .. "Sell "
			else
				itemid = l[1]
				text = text .. "Buy "
			end
			text = text .. ITEMS[itemid].name .. "|" .. l[2] .. ","
		end
		j.menu = text
	end
end
function npc_move()
	for i, j in ipairs(NPCs) do
		if j.static then
			for _,all in ipairs(player(0,"table")) do
				if player(all,"health") > 0 then
					if player(all,"x") >= j.pos[1]-700 and player(all,"x") <= j.pos[1]+700 and player(all,"y") >= j.pos[2]-700 and player(all,"y") <= j.pos[2]+700 then
						if j.static > 0 then
							j.static = j.static - 1
						elseif j.static == 0 then
							if j.xy then
								local move = math.random(1,3)
								if move == 1 then
									local rotation = math.random(1,3)
									if rotation == 1 then
										j.rot = math.random(1,120)
									elseif rotation == 2 then
										j.rot = math.random(121,240)
									elseif rotation == 3 then
										j.rot = math.random(241,360)
									end
									local radius = math.random(10,30)
									local x = j.pos[1] + radius * math.cos(j.rot)
									local y = j.pos[2] + radius * math.sin(j.rot)
									if tile(math.floor(x/32),math.floor(y/32),"walkable") then
										if x/32 > j.xy[1][1] and y/32 > j.xy[1][2] and x/32 < j.xy[2][1] and y/32 < j.xy[2][2] then
											j.rot = math.floor(math.deg(math.pi/2 + (math.atan2(y - j.pos[2], x - j.pos[1]))))
											j.pos[1] = x
											j.pos[2] = y
											tween_move(j.image,500,j.pos[1],j.pos[2],j.rot)
											tween_move(j.shadow,500,j.pos[1]+2,j.pos[2]+2,j.rot)
										end
									end
								end
							end
						end
						break
					end
				end
			end
		end
	end
end
function contains(words, text) words = words:lower(); return words == text or words:find(text .. " ") or words:find(" " .. text) end
function NPCspeak(npcid, words) return radiusmsg(string.format("\169175175175%s:\169255255255 %s", NPCs[npcid][1], words), NPCs[npcid].pos[1], NPCs[npcid].pos[2]) end
function setNPCpos(npcid, x, y, rot)
	NPCs[npcid].rot = rot or NPCs[npcid].rot
	NPCs[npcid].pos = (x and y) and {x*32+16, y*32+16} or NPCs[npcid].pos
end
addhook("say", "NPCsay")
function NPCsay(id, words)
	if player(id,"team") ~= 0 or not player(id,"dead") then
		words = words:lower()
		if PLAYERS[id].tmp.npcstate then
			local v = NPCs[PLAYERS[id].tmp.npcstate[1]]
			if inarea(player(id, "x"), player(id, "y"), v.pos[1]-96, v.pos[2]-96, v.pos[1]+96, v.pos[2]+96) then
				
				NPCs[PLAYERS[id].tmp.npcstate[1]].func(PLAYERS[id].tmp.npcstate[1], id, words, PLAYERS[id].tmp.npcstate[2])
				return
			else
				PLAYERS[id].tmp.npcstate = nil
			end
		end
		if contains(words, "hi") or contains(words, "hello") or contains(words, "yo") or contains(words, "hey") then
			for k, v in ipairs(NPCs) do
				if inarea(player(id, "x"), player(id, "y"), v.pos[1]-76, v.pos[2]-76, v.pos[1]+76, v.pos[2]+76) then
					if player(id,"health") == 0 then NPCspeak(k, "You cannot talk to me while you're dead!") return end
					if v.func then
						v.func(k, id, "hi")
					elseif v.menu then
						menu(id, v.menu)
					else
						NPCspeak(k, "Can't you see I'm busy lad? Piss off.")
						break
					end
					if v.greet then
						NPCspeak(k, string.format(v.greet, player(id, "name")))
					end
					if v.static then
						v.rot = math.floor(math.deg(math.pi/2 + (math.atan2(player(id,"y") - v.pos[2],player(id,"x") - v.pos[1]))))
						tween_rotate(v.image,200,v.rot)
						tween_rotate(v.shadow,200,v.rot)
						v.static = 7
					end
					break
				end
			end
		end
	end
end
addhook("menu", "NPCmenu")
function NPCmenu(id, title, button)
	for i, v in ipairs(NPCs) do
		if title == v[1] then
			if button == 0 then
				if v.bye then
					NPCspeak(i, v.bye)
				end
				return
			end
			local itemid = math.abs(v.trade[button][1])
			if itemid then
				sell = v.trade[button][1] < 0
				price = v.trade[button][2]
				if sell then
					if removeitem(id, itemid, 1, true) then
						addmoney(id, price)
						return menu(id, NPCs[i].menu)
					end
					msg2(id, "\169255150150[SERVER]:\169255255255 You do not have " .. ITEMS[itemid].article .. " " .. ITEMS[itemid].name .. " to sell.")
					return
				elseif addmoney(id, -price) then
					if additem(id, itemid, 1, true) then
						return menu(id, NPCs[i].menu)
					end
					msg2(id, "\169255150150[SERVER]:\169255255255 You do not have enough capacity.")
					return
				end
				msg2(id, "\169255150150[SERVER]:\169255255255 You do not have enough Gold.")
			end
			return
		end
	end
end