-- tw_func.lua --

function tw_join(id)
	Player[id] = {}
	Player[id].scalps = 0
	Player[id].ability = 0
	Player[id].ability_time = 0
	Player[id].ability_name = "None"
	Player[id].rank = 0
	Player[id].exp = 0
	Player[id].engineer = 0
	Player[id].menuid = 0
	Player[id].weaponid = 0
	Player[id].load = 0
	Player[id].medic = 0
	Player[id].streak = 0
	Player[id].heal = 0
	Player[id].mine = 0
	Player[id].carepackage = 0
	Player[id].turret = 0
	Player[id].turret_use = 0
	Player[id].turret_place = 0
	_ability_join(id)
	
	Turret[id] = {0,0}
	timer(1000,"tw_joinmsg",id)
	player_details()
end

function tw_joinmsg(id)
	id = tonumber(id)
	
	-- Join messages
	msg2(id,"\169000255000Welcome back '"..player(id,"name").."' (U.S.G.N.: "..player(id,"usgn")..") (IP: "..player(id,"ip")..")")
	msg2(id,"\169255100000"..game("sv_name").."")
	msg2(id,"\169150255255!comment <comment>\169255255255 - Leave us a comment/suggestion!")
	msg2(id,"\169255255255For help say \169150255255!help\169255255255, how to use the commands is also displayed.")
	-- Main hudtxt
	parse('hudtxt2 '..id..' 0 "\169255255255'..game("sv_name")..'" 450 100')
	parse('hudtxt2 '..id..' 1 "\169255255255www.theanalbagels.eu" 450 116')
end

function tw_leave(id)
	if Player[id].load == 1 then
		tw_save(id)
	end
	if Player[id].medic == 1 then
		if player(id,"team") == 1 then
			for all = 1, 16 do
				if player(all,"exists") then
					if player(all,"team") == 1 then
						medic_t = 0
						msg2(all,"\169255255255Your \169255150150medic \169255255255has left your team!")
						msg2(all,"\169255255255There is no medic on your team, say \169255150150!medic \169255255255to become your team's medic.")
					end
				end
			end
		elseif player(id,"team") == 2 then
			for all = 1, 16 do
				if player(all,"exists") then
					if player(all,"team") == 2 then
						medic_ct = 0
						msg2(all,"\169255255255Your \169150150255medic \169255255255has left your team!")
						msg2(all,"\169255255255There is no medic on your team, say \169150150255!medic \169255255255to become your team's medic.")
					end
				end
			end
		end
		Player[id].medic = 0
		freeimage(Player[id].medicicon)
	end
	if Player[id].engineer == 1 then
		if player(id,"team") == 1 then
			for all = 1, 16 do
				if player(all,"exists") then
					if player(all,"team") == 1 then
						msg2(all,"\169255255255An \169255150150engineer \169255255255has left your team!")
						msg2(all,"\169255255255There is an open space as engineer, say \169255150150!engineer")
					end
				end
			end
		elseif player(id,"team") == 2 then
			for all = 1, 16 do
				if player(all,"exists") then
					if player(all,"team") == 2 then
						msg2(all,"\169255255255An \169150150255engineer \169255255255has left your team!")
						msg2(all,"\169255255255There is an open space as engineer, say \169150150255!engineer")
					end
				end
			end
		end
		Player[id].engineer = 0
		freeimage(Player[id].engineericon)
	end
	if Player[id].turret_gun ~= nil then
		freeimage(Player[id].turret_gun)
		freeimage(Player[id].turret_stand)
		Turret[id] = {0,0}
	end
	if Player[id].turret_use == 1 then
		parse("speemod "..id.." 0")
		parse("strip "..id.." 90")
		Player[id].turret_use = 0
	end
	if Player[id].rankimage then
		freeimage(Player[id].rankimage)
	end
	Player[id].engineericon = nil
	Player[id].medicicon = nil
	Player[id].rankimage = nil
	Player[id].turret_gun = nil
	Player[id].turret_stand = nil
	Player[id].sayimage = nil
	Turret[id] = {0,0}
	player_details()
end

function tw_spawn(id)
	if Player[id].rank > 24 then
		Player[id].rank = 24
		tw_save(id)
	end
	if player(id,"team") == 1 then
		if medic_t ~= 1 then
			msg2(id,"\169255255255There is no medic on your team, say \169255150150!medic \169255255255to become your team's medic.")
		end
	elseif player(id,"team") == 2 then
		if medic_ct ~= 1 then
			msg2(id,"\169255255255There is no medic on your team, say \169150150255!medic \169255255255to become your team's medic.")
		end
	end
	parse('hudtxt2 '..id..' 2 "" 0 0')
	if Player[id].weaponid ~= 0 then
		parse("equip "..id.." "..Player[id].weaponid)
		parse("setweapon "..id.." "..Player[id].weaponid)
	end
	tw_hud(id)
end

function tw_hit(id,source,weapon,hpdmg,apdmg)
	_ability_hit(id,source,weapon,hpdmg,apdmg)
end

function tw_kill(killer,victim)
	if player(victim,"exists") then
		if player(victim,"team") ~= player(killer,"team") then
			msg2(killer,"\169000255000You have killed an enemy soldier!@C")
			msg2(killer,"\169255150150You get 1 scalp as a reward.@C")
			Player[killer].scalps = Player[killer].scalps + 1
			_updateRank(killer,100)
			tw_hud(killer)
		end
	end
	Player[killer].streak = Player[killer].streak + 1
	local c = ""
	if player(killer,"team") == 1 then
		c = "\169255150150"
	elseif player(killer,"team") == 2 then
		c = "\169150150255"
	end
	if Player[killer].streak == 3 then
		msg(""..c..""..player(killer,"name").."\169255255255 is on a killing spree!")
		msg2(killer,"\169255255255You have gained a "..c.."mine\169255255255!")
		msg2(killer,"\169255255255You can place this by saying "..c.."!mine")
		Player[killer].mine = Player[killer].mine + 1
	elseif Player[killer].streak == 5 then
		msg(""..c..""..player(killer,"name").."\169255255255 is on a rampage!")
		msg2(killer,"\169255255255You have gained a "..c.."carepackage\169255255255!")
		msg2(killer,"\169255255255You can place this by saying "..c.."!carepackage")
		Player[killer].carepackage = Player[killer].carepackage + 1
	elseif Player[killer].streak == 8 then
		msg(""..c..""..player(killer,"name").."\169255255255 is on a massacre!")
		msg2(killer,"\169255255255You have gained a "..c.."turret\169255255255!")
		msg2(killer,"\169255255255You can place this by saying "..c.."!turret")
		Player[killer].turret = Player[killer].turret + 1
	elseif Player[killer].streak == 10 then
		msg(""..c..""..player(killer,"name").."\169255255255 is on a holocaust!")
	elseif Player[killer].streak >= 15 then
		msg(""..c..""..player(killer,"name").."\169255255255 is unstoppable!")
	end
	if Player[victim].streak >= 3 then
		if player(killer,"team") == 1 then
			msg(""..c..""..player(killer,"name").."\169255255255 has ended \169150150255"..player(victim,"name").."'s\169255255255 "..Player[victim].streak.." kill streak.")
		elseif player(killer,"team") == 2 then
			msg("\169150150255"..player(killer,"name").."\169255255255 has ended "..c..""..player(victim,"name").."'s\169255255255 "..Player[victim].streak.." kill streak.")
		end
	end
end

function tw_die(id,killer)
	if Player[id].medic == 1 then
		if player(id,"team") == 1 then
			medic_t_tile[1] = 0
			medic_t_tile[2] = 0
		elseif player(id,"team") == 2 then
			medic_ct_tile[1] = 0
			medic_ct_tile[2] = 0
		end
	end
	if Player[id].turret_use == 1 then
		parse('hudtxt2 '..id..' 2 "" 324 420 1')
		freeimage(Player[id].turret_gun)
		Player[id].turret_gun = image("gfx/yates/lua/turret_gun.png",player(id,"x"),player(id,"y"),1)
		parse("strip "..id.." 90")
		Player[id].turret_use = 0
	end
	timer(500,"_weaponMenu",id)
	Player[id].heal = 0
	Player[id].streak = 0
	Player[id].pyro_time = 0
end

function tw_team(id)
	if Player[id].load ~= 1 then
		tw_load(id)
		Player[id].load = 1
	end
	if Player[id].medic == 1 then
		if player(id,"team") == 1 then
			for all = 1,16 do
				if player(all,"exists") then
					if player(all,"team") == 1 then
						medic_t = 0
						msg2(all,"\169255255255Your \169255150150medic \169255255255has left your team!")
						msg2(all,"\169255255255There is no medic on your team, say \169255150150!medic \169255255255to become your team's medic.")
					end
				end
			end
		elseif player(id,"team") == 2 then
			for all = 1,16 do
				if player(all,"exists") then
					if player(all,"team") == 2 then
						medic_ct = 0
						msg2(all,"\169255255255Your \169150150255medic \169255255255has left your team!")
						msg2(all,"\169255255255There is no medic on your team, say \169150150255!medic \169255255255to become your team's medic.")
					end
				end
			end
		end
		Player[id].medic = 0
		freeimage(Player[id].medicicon)
	end
	if Player[id].turret_gun ~= nil then
		freeimage(Player[id].turret_gun)
		freeimage(Player[id].turret_stand)
		Turret[id] = {0,0}
	end
	if Player[id].turret_use == 1 then
		parse("speemod "..id.." 0")
		parse("strip "..id.." 90")
		Player[id].turret_use = 0
	end
	timer(100,"_weaponMenu",id)
	timer(100,"tw_hud",id)
end

function tw_walkover(id,iid,type)
	if Player[id].predator == 1 then
		if type >= 79 and type <= 84 then
			return 1
		end
	end
	if type == 84 or type == 46 then
		return 1
	end
end

function tw_drop(id,iid,type)
	if Player[id].turret_use == 1 then
		return 1
	else
		return 0
	end
	if Player[id].pyromaniac == 1 then
		return 1
	else
		return 0
	end
end

function tw_use(id)
	if Turret[id][1] ~= 0 and Turret[id][2] ~= 0 then
		if player(id,"tilex") == Turret[id][1] and player(id,"tiley") == Turret[id][2] then
			if Player[id].turret_use ~= 1 then
				parse("setpos "..id.." "..(Turret[id][1]*32+16).." "..Turret[id][2]*32+16)
				parse('hudtxt2 '..id..' 2 "\169255255255..Click [E] to exit turret.." 324 420 1')
				parse("hudtxtcolorfade "..id.." 2 1000 0 255 0")
				freeimage(Player[id].turret_gun)
				Player[id].turret_gun = image("gfx/yates/lua/turret_gun.png",player(id,"x"),player(id,"y"),200+id)
				Player[id].turret_use = 1
				parse("speedmod "..id.." -100")
				parse("equip "..id.." 90")
				parse("setweapon "..id.." 90")
			else
				parse('hudtxt2 '..id..' 2 "" 324 420 1')
				freeimage(Player[id].turret_gun)
				Player[id].turret_gun = image("gfx/yates/lua/turret_gun.png",player(id,"x"),player(id,"y"),1)
				imagepos(Player[id].turret_gun,player(id,"tilex")*32+16,player(id,"tiley")*32+16,player(id,"rot"))
				Player[id].turret_use = 0
				parse("speedmod "..id.." 0")
				parse("strip "..id.." 90")
				parse("setweapon "..id.." 50")
			end
		end
	end
end

function tw_select(id,type)
	if Player[id].turret_use == 1 then
		if type ~= 90 then
			parse("setweapon "..id.." 90")
		end
	end
	if Player[id].pyromaniac == 1 then
		if type ~= 46 then
			parse("setweapon "..id.." 46")
		end
	end
end

function tw_serveraction(id,act)
	lvl = checkLevel(id)

	Player[id].button1 = "(VIP Menu|(Member))"
	Player[id].button2 = "(Admin Menu|(Admin))"
	if lvl >= 2 then
		Player[id].button1 = "VIP Menu|(Member)"
	end
	if lvl >= 5 then
		Player[id].button2 = "Admin Menu|(Admin)"
	end
	if act == 1 then
		menu(id,"Main Menu,Change Server|(Client),Shop|(Client),,Scalps|"..Player[id].scalps..",Weapons Menu|(Client),,"..Player[id].button1..","..Player[id].button2.."")
	elseif act == 2 then
		menu(id,"Shop - Page 1@b,Mine|Plant a mine using !mine - Cost: 5,Carepackage|Call in a carepackage (items) using !carepackage - Cost: 8,Controllable Turret|Place a controllable turret using !turret - Cost: 12,,,Predator|Invisible for 20 sec - Cost: 8,Pyromaniac|Weild a flamethrower for 15 sec - Cost: 12,Next|>>,(Back|<<)")
	elseif act == 3 then
		if player(id,"health") > 0 then
			if Player[id].ability_name ~= "None" then
				if Player[id].ability_time == 0 then
					if Player[id].ability == 0 then
						local pos = player(id,"x").." "..player(id,"y")
						
						msg2(id,"\169150255150[SERVER]:\169255255255 Your ability is charging!")
						parse("effect \"colorsmoke\" "..pos.." 50 50 255 255 255")
						timer(3000,"_ability_"..Player[id].ability_name.."",id)
						Player[id].ability = 1
					else
						msg2(id,"\169255150150[SERVER]:\169255255255 You have to wait until your current ability finishes!")
					end
				else
					msg2(id,"\169255150150[SERVER]:\169255255255 You have to wait until your cooldown ends!")
				end
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You have to buy an ability first!")
			end
		else
			msg2(id,"\169255150150[SERVER]:\169255255255 You are dead!")
		end
	end
end

function tw_dominate(id)
	if player(id,"team") == 1 then
		msg("\169255150150The Terrorists \169255255255have captured a domination point!")
		msg2(id,"\169000255000You have captured a domination point!@C")
		msg2(id,"\169255150150You get 3 scalps as a reward.@C")
	elseif player(id,"team") == 2 then
		msg("\169150150255The Counter-Terrorists \169255255255have captured a domination point!")
		msg2(id,"\169000255000You have captured a domination point!@C")
		msg2(id,"\169150150255You get 3 scalps as a reward.@C")
	end
	Player[id].scalps = Player[id].scalps + 3
	_updateRank(id,50)
	tw_hud(id)
end

function tw_buildattempt(id,type)
	if Player[id].engineer ~= 1 then
		msg2(id,"\169255150150[SERVER]:\169255255255 You are not an engineer! Say !engineer to become one.")
		return 1
	end
end

function tw_endround()
	for _,id in pairs(player(0,"table")) do
		if Player[id].medic == 1 then
			if player(id,"team") == 1 then
				medic_t = 0
			elseif player(id,"team") == 2 then
				medic_ct = 0
			end
			Player[id].medic = 0
			freeimage(Player[id].medicicon)
		end
		if Player[id].engineer == 1 then
			Player[id].engineer = 0
			freeimage(Player[id].engineericon)
		end
		if Player[id].turret_gun ~= nil then
			freeimage(Player[id].turret_gun)
			freeimage(Player[id].turret_stand)
			Turret[id] = {0,0}
		end
		if Player[id].turret_use == 1 then
			parse("speemod "..id.." 0")
			parse("strip "..id.." 90")
			Player[id].turret_use = 0
		end
		Player[id].engineericon = nil
		Player[id].medicicon = nil
		Player[id].rankimage = nil
		Player[id].turret_gun = nil
		Player[id].turret_stand = nil
	end
end

function tw_movetile(id)
	if Player[id].medic == 1 then
		if player(id,"team") == 1 then
			medic_t_tile[1] = player(id,"tilex")
			medic_t_tile[2] = player(id,"tiley")
		elseif player(id,"team") == 2 then
			medic_ct_tile[1] = player(id,"tilex")
			medic_ct_tile[2] = player(id,"tiley")
		end
	end
	if player(id,"team") == 1 then
		if medic_t_tile[1] ~= 0 and medic_t_tile[2] ~= 0 then
			if player(id,"tilex") == medic_t_tile[1] and player(id,"tiley") == medic_t_tile[2] then
				if Player[id].medic ~= 1 then
					Player[id].heal = 1
				end
			else
				Player[id].heal = 0
			end
		elseif medic_t_tile[1] == 0 and medic_t_tile[2] == 0 then
			Player[id].heal = 0
		end
	elseif player(id,"team") == 2 then
		if medic_ct_tile[1] ~= 0 and medic_ct_tile[2] ~= 0 then
			if player(id,"tilex") == medic_ct_tile[1] and player(id,"tiley") == medic_ct_tile[2] then
				if Player[id].medic ~= 1 then
					Player[id].heal = 1
				end
			else
				Player[id].heal = 0
			end
		elseif medic_ct_tile[1] == 0 and medic_ct_tile[2] == 0 then
			Player[id].heal = 0
		end
	end
	if player(id,"tilex") == Turret[id][1] and player(id,"tiley") == Turret[id][2] then
		parse('hudtxt2 '..id..' 2 "\169255255255..Click [E] to enter turret.." 324 420 1')
		parse("hudtxtcolorfade "..id.." 2 1000 0 255 0")
	else
		parse('hudtxt2 '..id..' 2 "" 324 420 1')
	end
	_ability_movetile(id)
end

function tw_menu(id,title,button)
	if title == "Main Menu" then
		if button == 1 then
			_menu(id)
		elseif button == 2 then
			menu(id,"Shop - Page 1@b,Mine|Plant a mine using !mine - Cost: 5,Carepackage|Call in a carepackage (items) using !carepackage - Cost: 8,Controllable Turret|Place a controllable turret using !turret - Cost: 12,,,Predator|Invisible for 20 sec - Cost: 8,Pyromaniac|Weild a flamethrower for 15 sec - Cost: 12,Next|>>,(Back|<<)")
		elseif button == 5 then
			Player[id].menuid = 0
			_weaponMenu(id)
		elseif button == 7 then
			msg2(id,"\169255150150[SERVER]:\169255255255 Sorry, there is nothing in this menu yet. Suggestions are welcome.")
		elseif button == 8 then
			menu(id,"Server Settings,Flashing Hudtxt")
		end
	end
	if title == "Server Settings" then
		if button == 1 then
			menu(id,"Flashing Hudtxt,Red|Yellow,Blue|Green,Purple|Orange,Black|White")
		end
	end
	if title == "Flashing Hudtxt" then
		if button == 1 then
			hudtxt_color1 = "255 0 0"
			hudtxt_color2 = "255 255 0"
		elseif button == 2 then
			hudtxt_color1 = "0 0 255"
			hudtxt_color2 = "0 255 0"
		elseif button == 3 then
			hudtxt_color1 = "180 0 255"
			hudtxt_color2 = "255 150 0"
		elseif button == 4 then
			hudtxt_color1 = "0 0 0"
			hudtxt_color2 = "255 255 255"
		end
	end
	if string.sub(title,1,16) == "Weapon Selection" then
		local mid = Player[id].menuid
		if (mid == 0) then
			if (button > 0 and button < 9) then
				if (Player[id].rank >= set_wpn_val(button,3)) then
					msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully selected the weapon: \169150150255"..set_wpn_val(button,1))
					msg2(id,"\169150255150[SERVER]:\169255255255 This weapon will be equipped once you re-spawn!")
					Player[id].weaponid = set_wpn_val(button,2)
				else
					Player[id].menuid = mid
					_weaponMenu(id)
					msg2(id,"\169255150150[SERVER]:\169255255255 You need a higher rank! (Required rank: "..set_wpn_val(button,3)..")")
				end
			elseif (button == 9) then
				Player[id].menuid = mid + 1
				_weaponMenu(id)
			end
		elseif (mid > 0) then
			local page = button + 8 + 7 * ( mid - 1)
			if (button > 0 and button < 8) then
				if (Player[id].rank >= set_wpn_val(page,3)) then
					msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully selected the weapon: \169150150255"..set_wpn_val(page,1))
					msg2(id,"\169150255150[SERVER]:\169255255255 This weapon will be equipped once you re-spawn!")
					Player[id].weaponid = set_wpn_val(page,2)
				else
					Player[id].menuid = mid
					_weaponMenu(id)
					msg2(id,"\169255150150[SERVER]:\169255255255 You need a higher rank! (Required rank: "..set_wpn_val(page,3)..")")
				end
			elseif (button == 8) then
				Player[id].menuid = mid -1
				_weaponMenu(id)
			elseif (button == 9) then
				Player[id].menuid =  mid + 1
				_weaponMenu(id)
			end
		end
	end
	if title == "Shop - Page 1" then
		if button == 1 then
			if Player[id].scalps >= 5 then
				Player[id].mine = Player[id].mine + 1
				Player[id].scalps = Player[id].scalps - 5
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought a mine!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 2 then
			if Player[id].scalps >= 8 then
				Player[id].carepackage = Player[id].carepackage + 1
				Player[id].scalps = Player[id].scalps - 8
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought a carepackage!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 3 then
			if Player[id].scalps >= 12 then
				Player[id].turret = Player[id].turret + 1
				Player[id].scalps = Player[id].scalps - 12
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought a turret!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 6 then
			if Player[id].scalps >= 8 then
				Player[id].ability_name = "predator"
				Player[id].scalps = Player[id].scalps - 8
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability predator!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 7 then
			if Player[id].scalps >= 12 then
				Player[id].ability_name = "pyromaniac"
				Player[id].scalps = Player[id].scalps - 12
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability pyromaniac!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 8 then
			menu(id,"Shop - Page 2@b,Toxygen|People close to you take damage and speed decrease - Cost: 13,Leech|Take HP from the enemy on hit - Cost: 15,Regeneration|Gain 5 to 10 HP every 3 seconds for 30 seconds - Cost: 17,Force field|Create a barrier that stops damage - Cost: 20,Kamikaze|Create a massive explosion that also fires rockets - Cost: 14,,,(Next|>>),Back|<<")
		end
		tw_hud(id)
	end
	if title == "Shop - Page 2" then
		if button == 1 then
			if Player[id].scalps >= 13 then
				Player[id].ability_name = "toxygen"
				Player[id].scalps = Player[id].scalps - 13
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability toxygen!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 2 then
			if Player[id].scalps >= 15 then
				Player[id].ability_name = "leech"
				Player[id].scalps = Player[id].scalps - 15
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability leech!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 3 then
			if Player[id].scalps >= 17 then
				Player[id].ability_name = "regeneration"
				Player[id].scalps = Player[id].scalps - 17
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability regeneration!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 4 then
			if Player[id].scalps >= 20 then
				Player[id].ability_name = "forcefield"
				Player[id].scalps = Player[id].scalps - 20
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability forcefield!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 5 then
			if Player[id].scalps >= 14 then
				Player[id].ability_name = "kamikaze"
				Player[id].scalps = Player[id].scalps - 14
				msg2(id,"\169150255150[SERVER]:\169255255255 You have successfully bought the ability kamikaze!")
			else
				msg2(id,"\169255150150[SERVER]:\169255255255 You do not have enough scalps to make this purchase.")
			end
		elseif button == 9 then
			menu(id,"Shop - Page 1@b,Mine|Plant a mine using !mine - Cost: 5,Carepackage|Call in a carepackage (items) using !carepackage - Cost: 8,Controllable Turret|Place a controllable turret using !turret - Cost: 12,,,Predator|Invisible for 20 sec - Cost: 8,Pyromaniac|Weild a flamethrower for 15 sec - Cost: 12,Next|>>,(Back|<<)")
		end
		tw_hud(id)
	end
end

function tw_buy(id,weapon)
	return 1
end

function tw_second()
	for _,all in pairs(player(0,"table")) do
		if Player[all].ability_time ~= 0 then
			Player[all].ability_time = Player[all].ability_time - 1
			if Player[all].ability_time == 0 then
				msg2(all,"\169150255150[SERVER]:\169255255255 Your ability cooldown has ended!")
				msg2(all,"\169150255150[SERVER]:\169255255255 Press F4 to use your ability.")
			end
			tw_hud(all)
		end
		if Player[all].heal == 1 then
			if player(all,"team") == 1 then
				if player(all,"tilex") == medic_t_tile[1] and player(all,"tiley") == medic_t_tile[2] then
					if player(all,"health") ~= 100 then
						parse("sv_sound2 "..all.." yates/lua/regenerate.wav")
						parse("sethealth "..all.." "..player(all,"health")+5)
					end
				end
			elseif player(all,"team") == 2 then
				if player(all,"tilex") == medic_ct_tile[1] and player(all,"tiley") == medic_ct_tile[2] then
					if player(all,"health") ~= 100 then
						parse("sv_sound2 "..all.." yates/lua/regenerate.wav")
						parse("sethealth "..all.." "..player(all,"health")+5)
					end
				end
			end
		end
	end
	_ability_second()
end

function tw_minute()
	for i=1,32 do
		if player(i,"exists") then
			if Player[i].muted > 0 then
				Player[i].muted = Player[i].muted - 1
			end
		end
	end
	minute_info = minute_info + 1
	if minute_info == 1 then
		msg("\169255255255This server is powered by")
		msg("\169150255255www.theanalbagels.eu")
	elseif minute_info == 2 then
		msg("\169255255255We are looking for new clan members.")
		msg("\169255255255Please visit \169150255255"..site.."\169255255255 and apply!")
	elseif minute_info == 3 then
		msg("\169150255255!comment <comment>\169255255255 - Leave us a comment/suggestion!")
		msg("\169255255255For help say \169150255255!help\169255255255, if you need help with commands say \169150255255!help <command>")
	elseif minute_info == 4 then
		msg("\169150255255Scalps\169255255255 can be spent in the \169150255255Shops\169255255255 for special items!")
	elseif minute_info == 5 then
		msg("\169255255255[F1] - \169150255255Server Information")
		msg("\169255255255[F2] - \169150255255Main Menu")
		msg("\169255255255[F3] - \169150255255Shop Menu")
		msg("\169255255255[F4] - \169150255255Use Ability")
		minute_info = 0
	end
	details_log = io.open("sys/lua/tw_logs/"..os.date("%B").."-"..os.date("%d").."-"..os.date("%Y")..".txt","a")
	details_log:write(""..os.date("%A").." - "..os.date("%d").." "..os.date("%B").." "..os.date("%Y").." - "..os.date("%I:%M %p").."\n")
	details_log:close()
	for all = 1,32 do
		if player(all,"exists") then
			details_log = io.open("sys/lua/tw_logs/"..os.date("%B").."-"..os.date("%d").."-"..os.date("%Y")..".txt","a")
			details_log:write("(ID: "..all..") (Name: "..player(all,"name")..") (U.S.G.N: "..player(all,"usgn")..") (IP: "..player(all,"ip")..")\n")
			details_log:close()
		end
	end
	print("\169000255000Player logs saved.")
	player_details()
end

-- Custom functions

function tw_hud(id)
	id = tonumber(id)
	
	if Player[id].scalps > scalps_max then
		Player[id].scalps = scalps_max
	end
	local c = ""
	if player(id,"team") == 1 then
		c = "\169255150150"
	elseif player(id,"team") == 2 then
		c = "\169150150255"
	end
	parse('hudtxt2 '..id..' 3 "'..c..'Scalps:\169255255255 '..Player[id].scalps..'/'..scalps_max..'" 5 425')
	parse('hudtxt2 '..id..' 4 "'..c..'Cooldown:\169255255255 '..Player[id].ability_time..'" 110 425')
	parse('hudtxt2 '..id..' 6 "'..c..''..ranknme[Player[id].rank]..' (#'..Player[id].rank..')" 630 395 2')
	parse('hudtxt2 '..id..' 7 "\169150255150Exp:" 480 410')
	parse('hudtxt2 '..id..' 8 "\169255255255'..Player[id].exp..'/'..rankexp[Player[id].rank+1]..'" 630 410 2')
	parse('hudtxt2 '..id..' 9 "\169150255150Kill Streak:" 480 425')
	parse('hudtxt2 '..id..' 10 "\169255255255'..Player[id].streak..'" 630 425 2')
	if Player[id].rankimage then
		freeimage(Player[id].rankimage)
		Player[id].rankimage = nil
	end
	Player[id].rankimage = image("gfx/yates/ranks/"..rankloc[Player[id].rank]..".png",0,-1,200+id)
end

-- Load/Save

function tw_load(id)
	local usgn = player(id,"usgn")
	if usgn > 0 then
		local file = io.open("sys/lua/trench_wars/saves/"..usgn..".txt","r")
		if file then
			local r, e, s = file:read("*n","*n","*n")
			Player[id].rank = r
			Player[id].exp = e
			Player[id].scalps = s
			msg2(id,"\169150255150[SERVER]:\169255255255 Save file found.")
			msg2(id,"\169150255150[SERVER]:\169255255255 Welcome back "..player(id,"name").." - Logged in with U.S.G.N. "..player(id,"usgn")..".")
			file:close()
		else
			msg2(id,"\169255150150[SERVER]:\169255255255 Failed to load your save.")
			Player[id].scalps = 0
		end
	else
		msg2(id,"\169255150150[SERVER]:\169255255255 You are not logged in. Please register an account at UnrealSoftware.de")
		Player[id].scalps = 0
	end
	tw_hud(id)
	timer(0,"tw_hud",id)
end

function tw_save(id)
	local usgn = player(id,"usgn")
	if usgn > 0 then
		local file = io.open("sys/lua/trench_wars/saves/"..usgn..".txt","w")
		local r, e, s = Player[id].rank, Player[id].exp, Player[id].scalps
		file:write(r.."\n"..e.."\n"..s)
		print("\169000255000Saved.")
		file:close()
	end
end

function _updateRank(id,gain)
	if ranknme[Player[id].rank] ~= "General of the Army" then
		Player[id].exp = Player[id].exp + gain
		parse('hudtxt2 '..id..' 11 "\169255255255+'..gain..'" 318 215 1')
		parse("hudtxtalphafade "..id.." 11 1000 0")
		parse("hudtxtmove "..id.." 11 1500 318 180")
		if Player[id].exp >= rankexp[Player[id].rank+1] then
			msg2(id,"\169000255000You have been promoted!@C")
			Player[id].rank = Player[id].rank + 1
			freeimage(Player[id].rankimage)
			Player[id].rankimage = nil
			Player[id].rankimage = image("gfx/yates/ranks/"..rankloc[Player[id].rank]..".png",0,-1,200+id)
		end
	end
	tw_hud(id)
end

function _loadWeapons()
	f = io.open("sys/lua/trench_wars/weapons.cfg","r")
	if (f ~= nil) then
		local weapon_cnt = 0
		local m = 0
		print("[SERVER]: Found weapon config file.")
		for line in f:lines() do
			m = m + 1
			if (string.sub(line, 1, 10) == '#addweapon') then
				local breaking = 0
				weapon_cnt = weapon_cnt + 1
				local load_string = string.split(line,':')
				local i
				for i = 1, 3 do
					if (load_string[i + 1] ~= nil) then
						if (i > 1) then
							set_wpn_stata(weapon_cnt,i,tonumber(load_string[i + 1]))
						elseif (i < 2) then
							set_wpn_stata(weapon_cnt,i,load_string[i + 1])
						end
					elseif (load_string[i + 1] == nil and breaking < 1) then
						print("[SERVER]: Weapon parameter missing, line "..m..".")
						set_wpn_stata(weapon_cnt,1,nil)
						breaking = 1
						weapon_cnt = weapon_cnt  - 1
					end
				end
				if (breaking == 0) then
					print("[SERVER]: Weapon Added: "..set_wpn_val(weapon_cnt,1)..", Rank: "..set_wpn_val(weapon_cnt,3)..".")
				end
			end
		end
		tw_weapons_cnt = weapon_cnt
		f:close()
	else
		print("[SERVER]: Cannot locate weapon config file!")
	end
end

function _weaponMenu(id)
	id = tonumber(id)
	
	local i
	local weapon = ''
	local mid = Player[id].menuid
	if (mid == 0) then
		for i = 1, 8 do
			if (set_wpn_val(i,1) ~= nil) then
				if (Player[id].rank >= set_wpn_val(i,3)) then
					weapon = weapon..''..set_wpn_val(i,1)..'|(Rank '..set_wpn_val(i,3)..'),'
				else
					weapon = weapon..'('..set_wpn_val(i,1)..'|(Rank '..set_wpn_val(i,3)..')),'
				end
			end
		end
		if (set_wpn_val(9,1) ~= nil) then 
			weapon = weapon..'Next >>'
		end
	elseif (mid > 0) then
		for i = 9 + 7 * (mid - 1), 15 +  7 * (mid - 1) do
			if (set_wpn_val(i,1) ~= nil) then
				if (Player[id].rank >= set_wpn_val(i,3)) then
					weapon = weapon..''..set_wpn_val(i,1)..'|(Rank '..set_wpn_val(i,3)..'),'
				else
					weapon = weapon..'('..set_wpn_val(i,1)..'|(Rank '..set_wpn_val(i,3)..')),'
				end
			else
				weapon = weapon..','
			end
		end
		weapon = weapon..'<< Back,'
		if (15 +  7 * (mid - 1) < tw_weapons_cnt) then 
			weapon = weapon..'Next >>'
		end
	end
	menu(id,"Weapon Selection - Page "..(1 + mid)..","..weapon)
end

function _buildingCheck(id,type)
	local current = 0
	for _,all in pairs(object(0,"table")) do
		if object(all,"team") == player(id,"team") and object(all,"type") == type then
			current = current + 1
		end
	end
	if player(id,"team") == 1 then
		if current < t_buildings[type] then
			return true
		else
			return false
		end
	else
		if current < ct_buildings[type] then
			return true
		else
			return false
		end
	end
end

function set_wpn_val(id,n)
	local set_val
	set_val = tw_weapon_stats[5 * (id - 1) + n]
	return set_val
end

function set_wpn_stata(id,n,m)
	tw_weapon_stats[5 * (id - 1) + n] = m
end

function string.split(t,b)
	local cmd = {}
	local match = "[^%s]+"
	if type(b) == "string" then match = "[^"..b.."]+" end
	for word in string.gmatch(t, match) do table.insert(cmd, word) end
	return cmd
end 