-- The Anal Bagels Admin Script --

dir = "/home/ftpuser/cs2d/"
l33t = {}
adm = {}
mod = {}
gm = {}
mem = {}
vip = {}

cmds      = {"!help","!pm","!usgn","!report","!comment","!abc","!kick","!mute","!unmute","!makect","!maket","!makespec","!tempban","!slap","!kill","!ban","!add","!remove","!addusgn","!removeusgn","!reloadlua","!lua","!s","!duty","!freeze","!bring","!goto","!bigears","!lastplayers","!whois","!notag"}
cmd_lvl   = {1      ,1    ,1	  ,1        ,1         ,4     ,3      ,4      ,4        ,4        ,4       ,4          ,4         ,4      ,4      ,4     ,7     ,7        ,7         ,7             ,7          ,7     ,6	,4	    ,5        ,5       ,5      ,4         ,4             ,1       ,2}
cmd_helps = {"!help","!pm <id> <message>","!usgn <id>","!report <id> <reason>","!comment <comment>","!abc <text>","!kick <id> <reason>","!mute <id>","!unmute <id>","!makect <id>","!maket <id>","!makespec <id>","!tempban <id>","!slap <id>","!kill <id>","!ban <id>","!add <A/M/T/P> <id>","!remove <id>","!addusgn <A/M/T/P> <U.S.G.N. ID>","!removeusgn <U.S.G.N. ID>","!reloadlua","!lua <lua command>","!s <text>","!duty","!freeze <id>","!bring <id>","!goto <id>","!bigears","!lastplayers <minutes>","!whois <id>","!notag"}

_id = 0
_txt = ""
_tbl = {}

lastlogged = {}
geoip = dofile(dir.."geoip.lua")
geoip:load(dir.."IpToCountry.csv")

usgndb = dofile(dir.."usgnlookup.lua")
usgndb:load(dir.."UsgnToCountry.csv")

function toTable(str,mch)
	local tmp = {}
	if not mch then mch = "[^%s]+" else mch = "[^"..mch.."]+" end
	for wrd in string.gmatch(str,mch) do
		table.insert(tmp, wrd)
	end
	return tmp
end

function loadUsers()
	local o = io.open(dir.."l33t.lst","r")
	local a = io.open(dir.."adm.lst","r")
	local m = io.open(dir.."mod.lst","r")
	local g = io.open(dir.."gm.lst","r")
	local n = io.open(dir.."mem.lst","r")
	local v = io.open(dir.."vip.lst","r")
	local oc = o:read("*all")
	local ac = a:read("*all")
	local mc = m:read("*all")
	local gc = g:read("*all")
	local nc = n:read("*all")
	local vc = v:read("*all")
	local ot = toTable(oc,",")
	local at = toTable(ac,",")
	local mt = toTable(mc,",")
	local gt = toTable(gc,",")
	local nt = toTable(nc,",")
	local vt = toTable(vc,",")
	for _,v in pairs(ot) do
		table.insert(l33t,tonumber(v))
	end
	for _,v in pairs(at) do
		table.insert(adm,tonumber(v))
	end
	for _,v in pairs(mt) do
		table.insert(mod,tonumber(v))
	end
	for _,v in pairs(gt) do
		table.insert(gm,tonumber(v))
	end
	for _,v in pairs(nt) do
		table.insert(mem,tonumber(v))
	end
	for _,v in pairs(vt) do
		table.insert(vip,tonumber(v))
	end
	
end

function addUser(level,usgn)
	local userfile
	if level == 7 and not tableFind(l33t,usgn) then
		table.insert(l33t,usgn)
		userfile = io.open(dir.."l33t.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	elseif level == 6 and not tableFind(adm,usgn) then
		table.insert(adm,usgn)
		userfile = io.open(dir.."adm.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	elseif level == 5 and not tableFind(mod,usgn) then
		table.insert(mod,usgn)
		userfile = io.open(dir.."mod.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	elseif level == 4 and not tableFind(gm,usgn) then
		table.insert(gm,usgn)
		userfile = io.open(dir.."gm.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	elseif level == 3 and not tableFind(mem,usgn) then
		table.insert(mem,usgn)
		userfile = io.open(dir.."mem.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	elseif level == 2 and not tableFind(vip,usgn) then
		table.insert(vip,usgn)
		userfile = io.open(dir.."vip.lst","a")
		userfile:write(usgn..",")
		io.close(userfile)
	end
end

function removeUser(usgn)
	local file
	local file_content = ""
	local o = tableFind(l33t,usgn)
	if o ~= false then
		table.remove(l33t,o)
		file = io.open(dir.."l33t.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		print(file_content)
		file = io.open(dir.."l33t.lst","w+")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
	local a = tableFind(adm,usgn)
	if a ~= false then
		table.remove(adm,a)
		file = io.open(dir.."adm.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		print(file_content)
		file = io.open(dir.."adm.lst","w+")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
	local m = tableFind(mod,usgn)
	if m ~= false then
		table.remove(mod,m)
		file = io.open(dir.."mod.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		file = io.open(dir.."mod.lst","w")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
	local g = tableFind(gm,usgn)
	if g ~= false then
		table.remove(gm,g)
		file = io.open(dir.."gm.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		print(file_content)
		file = io.open(dir.."gm.lst","w+")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
	local n = tableFind(mem,usgn)
	if n ~= false then
		table.remove(mem,n)
		file = io.open(dir.."mem.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		file = io.open(dir.."mem.lst","w")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
	local v = tableFind(vip,usgn)
	if v ~= false then
		table.remove(vip,v)
		file = io.open(dir.."vip.lst","r")
		file_content = file:read("*all")
		io.close(file)
		file_content = string.gsub(file_content, usgn..",", "")
		file = io.open(dir.."vip.lst","w")
		file:write(file_content)
		file:flush()
		io.close(file)
	end
end

loadUsers()

function tableFind(tbl, arg) -- returns the key to the first place it finds arg
	for k,v in pairs(tbl) do
		if v == arg then
			return k
		end
	end
	return false
end

function joinToString(...)
	local str = ""
	for i=1,#arg do
		str = (str.." "..arg[i])
	end
	return str
end

function checkLevel(id)
	local usgn = player(id,"usgn")
	if ( tableFind(l33t,usgn) ~= false ) then
		return 7
	elseif ( tableFind(adm,usgn) ~= false ) then
		return 6
	elseif ( tableFind(mod,usgn) ~= false ) then
		return 5
	elseif ( tableFind(gm,usgn) ~= false ) then
		return 4
	elseif ( tableFind(mem,usgn) ~= false ) then
		return 3
	elseif ( tableFind(vip,usgn) ~= false ) then
		return 2
	else
		return 1
	end
end

-- Standard Functions

function __join(id)
    Player[id].bigears = 0
    Player[id].duty = 0
    Player[id].freeze = 0
    Player[id].muted = 0
    Player[id].msgs = 0
    Player[id].cd = 0
    Player[id].cds = 0
    for k, v in pairs(lastlogged) do
        if (v.ip == player(id, "ip")) then
            local oldname
            if (player(id, "name") ~= v.name) then
                oldname = v.name
            end
            lastlogged[k] = {ip = player(id, "ip"), usgn = player(id, "usgn"), time = os.time(), name = player(id, "name"), id = id}
            if (oldname) then
                if (not lastlogged[k].names) then lastlogged[k].names = {} end
                table.insert(lastlogged[k].names, oldname)
            end
            return
        end
    end
    table.insert(lastlogged, {ip = player(id, "ip"), usgn = player(id, "usgn"), time = os.time(), name = player(id, "name"), id = id})
end
addhook("join", "__join", 10)

function __leave(id)
    if Player[id] and Player[id].duty == 1 then
        freeimage(Player[id].dutyi1)
        freeimage(Player[id].dutyi2)
        Player[id].dutyi1 = nil
        Player[id].dutyi2 = nil
    end
    for k, v in pairs(lastlogged) do
        if (v.id == id and v.ip == player(id, "ip")) then
            v.id = 0
            v.time = os.time()
            timer(600000, "parse", "lua table.remove(lastlogged,"..k..")") -- TODO: Remove lastlogged from global namespace
        end
    end
end
addhook("leave", "__leave", 10)

function __say(id,txt)
	local tbl = toTable(txt)
	local cmd = tbl[1]
	
	if (Player[id].cd > 0) then
           msg2(id,"\169255150150[SERVER]:\169255255255 You have been muted to prevent spam! You may talk again in "..Player[id].cd.." seconds.")
           return 1
       else
	    Player[id].msgs = Player[id].msgs + 1
           if (Player[id].msgs > 5) then
               Player[id].cd = 20
               if (Player[id].cds > 0) then Player[id].cd = Player[id].cd + Player[id].cds end
               Player[id].cds = Player[id].cds + 40
           end
       end

	if txt:sub(1,1) == "!" then
		if commandCheck(cmd) then
			for k,v in pairs(cmds) do
				if cmd == v then
					if( checkLevel(id) >= cmd_lvl[k] ) then
						_id = id
						_txt = txt
						_tbl = toTable(txt)
						tmp = loadstring("say_"..string.sub(cmd,2,string.len(cmd)).."()")
						tmp()
						_id = 0
						_txt = ""
						_tbl = {}
						return 1
					else
						msg2(id,"\169255150150[SERVER]:\169255255255 You do not have sufficient privaleges to use the command '"..cmd.."'")
						return 1
					end
				end
			end
		else
			msg2(id,"\169255150150[SERVER]:\169255255255 This command does not exist!")
			return 1
		end
	end
	
	lvl = checkLevel(id)
	
	if ( txt == "rank" ) then return 0 end
	
	if Player[id].muted == 0 then
		if (not Player[id].notag) then
			return say(id,txt,checkLevel(id))
		else
			return say(id,txt,1)
		end
	else
		msg2(id,"\169255150150[SERVER]:\169255255255 You have been muted! You can talk again in "..Player[id].muted.." minutes!")
		return 1
	end
end
addhook("say", "__say", -10)

local ticker = 0
function __second()
    for _, id in pairs(player(0, "table")) do
        if (Player[id].muted > 0) then
            Player[id].muted = Player[id].muted - 1
        end

        if (Player[id].cd > 0) then
            Player[id].cd = Player[id].cd - 1
        end

        ticker = ticker + 1
        if (ticker == 2) then
            if (Player[id].msgs > 0) then Player[id].msgs = Player[id].msgs - 1 end
            ticker = 0
        end

        if (Player[id].cds > 0) then
            Player[id].cds = Player[id].cds - 1
        end
    end
    for k = #lastlogged, 1, -1 do
        local v = lastlogged[k]
        if (os.time()-v.time >= 600) then
            table.remove(lastlogged, k)
        end
    end
end
addhook("second", "__second")

function __parse(cmd)
    if (cmd:sub(1,4) == "slua") then
        loadstring(cmd:sub(6))()
        return 2
    end
end
addhook("parse", "__parse")

-- Custom Functions

function commandCheck(txt)
	for whatever = 1, #cmds do
		if txt == cmds[whatever] then
			return true
		end
	end
	return false
end

function say_help()
  local tbl = _tbl
	if tbl[2] then
	 local level = checkLevel(_id)
		for k,v in pairs(cmds) do
			if tbl[2] == string.sub(v,2,string.len(v)) then
				msg2(_id,"")
				msg2(_id,"\169255255255USAGE:")
				msg2(_id,"\169200200200"..cmd_helps[k])
			end
		end
	else
		local level = checkLevel(_id)
		for i=1,#cmds do
			if(cmd_lvl[i] <= level) then
				msg2(_id,"\169255255255"..cmds[i])
			end
		end
		msg2(_id,"\169150255150[SERVER]:\169255255255 Say !help <command> to see how you use them.")
	end
end

function say_pm()
	local tbl = _tbl
	local str = ""
	
	if not tbl[2] then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You must enter a player ID!")
		return
	elseif not player(tbl[2],"exists") then
		msg2(_id,"\169255150150[SERVER]:\169255255255 This player does not exist!")
		return
    end

    if tonumber(_id) == tonumber(tbl[2]) then
        msg2(_id,"\169255150150[SERVER]:\169255255255 You cannot PM yourself!")
        return
    end

	for i=3,#tbl do
		str = (str.." "..tbl[i])
	end
	
	msg2(tbl[2],"\169255200250[PM < "..player(_id,"name").." (".._id..")]:"..str)
	msg2(_id,"\169255200250[PM > "..player(tbl[2],"name").." ("..tbl[2]..")]:"..str)
    print("["..player(_id,"name").." (".._id..") > "..player(tbl[2],"name").." ("..tbl[2]..")]:"..str)
    for _,all in pairs(player(0,"table")) do
        if Player[all].bigears == 1 then
            if all ~= tonumber(_id) and all ~= tonumber(tbl[2]) then
                msg2(all,"\169255200250["..player(_id,"name").." (".._id..") > "..player(tbl[2],"name").." ("..tbl[2]..")]:"..str)
            end
        end
    end
end

function say_usgn()
	local tbl = _tbl
	tbl[2] = tonumber(tbl[2])
	if tbl[2] and player(tbl[2], 'exists') then
		local usgn = player(tbl[2], 'usgn')
		if usgn ~= 0 then
			msg2(_id,"\169150255150[SERVER]:\169255255255 "..player(tbl[2],"name").."'s U.S.G.N is "..usgn..".")
			return
		else
			msg2(_id,"\169255150150[SERVER]:\169255255255 "..player(tbl[2],"name").." is not logged in to U.S.G.N.")
			return
		end
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 This player ID does not exist!")
	end
end

function say_report()
	local tbl = _tbl
	local reason = ""
	
	if not tbl[2] then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You must enter a player ID!")
		return
	end
	
	if not tbl[3] then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have not entered any reason!")
		return
	end
	
	for i=3,#tbl do
		reason = (reason.." "..tbl[i])
	end
 
	report_log = io.open("sys/lua/report_log.txt","a")
	report_log:write(player(tonumber(_id),"usgn").." | "..player(tonumber(_id),"ip").." >> "..player(tonumber(tbl[2]),"usgn").." | "..player(tonumber(tbl[2]),"ip").." ="..reason.."\n")
	report_log:close()
	msg2(_id,"\169150255150[SERVER]:\169255255255 Your report has been submitted, thank you!")
	msg2(_id,"\169255255255(YOUR REASON):"..reason.."")

	os.execute('python '..dir..'reporter.py -m 0 -t "'..reason..'" -s '..game("sv_hostport")..' --fromusgn '..player(tonumber(_id),"usgn")..' --fromip '..player(tonumber(_id),"ip")..' --tousgn '..player(tonumber(tbl[2]),"usgn")..' --toip '..player(tonumber(tbl[2]),"ip")..' &')
end

function say_comment()
	local tbl = _tbl
	local comment = ""
	
	if not tbl[2] then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have not entered any comment/suggestion!")
	end
	
	for i=2,#tbl do
		comment = (comment.." "..tbl[i])
	end
	
	comment_log = io.open("sys/lua/comment_log.txt","a")
	comment_log:write(player(tonumber(_id),"usgn").." | "..player(tonumber(_id),"ip").." ="..comment.."\n")
	comment_log:close()
	msg2(_id,"\169150255150[SERVER]:\169255255255 Your comment has been submitted, thank you!")
	msg2(_id,"\169255255255(YOUR COMMENT):"..comment.."")

	os.execute('python '..dir..'reporter.py -m 1 -t "'..comment..'" -s '..game("sv_hostport")..' --fromusgn '..player(tonumber(_id),"usgn")..' --fromip '..player(tonumber(_id),"ip")..' &')
end

function say_abc()
	local tbl = _tbl
	local txt = ""
	
	if not tbl[2] then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You cannot send an empty string!")
		return
	end
	
	for i=2,#tbl do
		txt = (txt.." "..tbl[i])
	end
	for _,all in pairs(player(0,"table")) do
		if checkLevel(all) >= 4 then
			msg2(all,"\169000150255[ABC] "..player(_id,"name")..":\169255255255"..txt)
		end
	end
end

function say_kick()
	local tbl = _tbl
	local reason = ""
	if tbl[3] then 
		reason = tbl[3].."." 
	else 
		reason = "No reason specified." 
	end
	
	if checkLevel(_id) > checkLevel(tbl[2]) then
		msg("\169255150150[SERVER]:\169255255255 Player '"..player(tonumber(tbl[2]),"name").."' has been kicked!")
		parse("kick "..tbl[2].." "..reason)
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_mute()
	local tbl = _tbl
	if checkLevel(_id) > checkLevel(tbl[2]) then
		if tbl[3] then
			if tonumber(tbl[3]) <= 10 then
				Player[tonumber(tbl[2])].muted = tonumber(tbl[3])*60
				msg("\169255150150[SERVER]:\169255255255 Player '"..player(tonumber(tbl[2]),"name").."' has been muted for "..Player[tonumber(tbl[2])].muted.." minutes.")
			else
				msg2(_id,"\169255150150[SERVER]:\169255255255 Max mute limit is 10.")
			end
		else
			Player[tonumber(tbl[2])].muted = 60
			msg("\169255150150[SERVER]:\169255255255 Player '"..player(tonumber(tbl[2]),"name").."' has been muted for "..Player[tonumber(tbl[2])].muted.." minute.")
		end
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_unmute()
	local tbl = _tbl
	Player[tonumber(tbl[2])].muted = 0
end

function say_maket()
	local tbl = _tbl
    if checkLevel(_id) > checkLevel(tbl[2]) then
	    parse("maket "..tbl[2])
    else
        msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
    end
end

function say_makect()
	local tbl = _tbl
    if checkLevel(_id) > checkLevel(tbl[2]) then
	    parse("makect "..tbl[2])
    else
        msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
    end
end

function say_makespec()
	local tbl = _tbl
    if checkLevel(_id) > checkLevel(tbl[2]) then
	    parse("makespec "..tbl[2])
    else
        msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
    end
end

function say_tempban()
	local tbl = _tbl
	local ip = player(tonumber(tbl[2]),"ip")
	local usgn = player(tonumber(tbl[2]),"usgn")
	if checkLevel(_id) > checkLevel(tbl[2]) then
		msg("\169255150150[SERVER]:\169255255255 Player '"..player(tonumber(tbl[2]),"name").."' has been temp banned!")
		parse("banip "..ip.." 1440")
		parse("banusgn "..usgn.." 1440")
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_slap()
	local tbl = _tbl
    if checkLevel(_id) > checkLevel(tbl[2]) then
	    parse("slap "..tbl[2])
    else
        msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
    end
end

function say_kill()
	local tbl = _tbl
	if player(tonumber(tbl[2]),"health") == 0 then
		msg2(_id,"\169255150150[SERVER]:\169255255255 You can't kill a dead person!")
		return 1
	end
	if checkLevel(_id) > checkLevel(tbl[2]) then
		parse("killplayer "..tbl[2])
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_ban()
	local tbl = _tbl
	local ip = player(tonumber(tbl[2]),"ip")
	local usgn = player(tonumber(tbl[2]),"usgn")
	if checkLevel(_id) > checkLevel(tbl[2]) then
		msg("\169255150150[SERVER]:\169255255255 Player '"..player(tonumber(tbl[2]),"name").."' has been banned!")
		parse("banip "..ip)
		parse("banusgn "..usgn)
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_add()
	local tbl = _tbl
	if string.lower(string.sub(tbl[2],1)) == "o" then
		addUser(7,player(tonumber(tbl[3]),"usgn"))
	elseif string.lower(string.sub(tbl[2],1)) == "a" then
		addUser(6,player(tonumber(tbl[3]),"usgn"))
	elseif string.lower(string.sub(tbl[2],1)) == "m" then
		addUser(5,player(tonumber(tbl[3]),"usgn"))
	elseif string.lower(string.sub(tbl[2],1)) == "g" then
		addUser(4,player(tonumber(tbl[3]),"usgn"))
	elseif string.lower(string.sub(tbl[2],1)) == "t" then
		addUser(3,player(tonumber(tbl[3]),"usgn"))
	elseif string.lower(string.sub(tbl[2],1)) == "p" then
		addUser(2,player(tonumber(tbl[3]),"usgn"))
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 No such level as '"..tbl[2].."'!!")
	end
end

function say_remove()
	local tbl = _tbl
	if tonumber(tbl[2]) == _id then
		msg2(_id,"\169255150150[SERVER]:\169255255255 Can't remove yourself!")
		return 1
	end
	if checkLevel(_id) > checkLevel(tbl[2]) then
		local usgn = player(tonumber(tbl[2]),"usgn")
		removeUser(usgn)
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
	end
end

function say_addusgn()
	local tbl = _tbl
	if string.lower(string.sub(tbl[2],1)) == "o" then
		addUser(7,tonumber(tbl[3]))
	elseif string.lower(string.sub(tbl[2],1)) == "a" then
		addUser(6,tonumber(tbl[3]))
	elseif string.lower(string.sub(tbl[2],1)) == "m" then
		addUser(5,tonumber(tbl[3]))
	elseif string.lower(string.sub(tbl[2],1)) == "g" then
		addUser(4,tonumber(tbl[3]))
	elseif string.lower(string.sub(tbl[2],1)) == "t" then
		addUser(3,tonumber(tbl[3]))
	elseif string.lower(string.sub(tbl[2],1)) == "p" then
		addUser(2,tonumber(tbl[3]))
	else
		msg2(_id,"\169255150150[SERVER]:\169255255255 No such level/type as '"..tbl[2].."'!")
	end
end

function say_removeusgn()
	removeUser(tonumber(_tbl[2]))
end

function say_reloadlua()
	msg("\169150255150[SERVER]:\169255255255 Please stay! We are reloading our lua scripts!@C")
	timer(3000,"parse","map "..game("sv_map"))
end

function say_lua()
	local script = _txt:sub(6)
	if script then
		msg2(_id,tostring(assert(loadstring(script))() or '\169150255150[SERVER]:\169255255255 Command executed!'))
	end
end

function say_s()
	local text = _txt:sub(4)
	if text then
		msg("\169150150255[SERVER]:\169255255255 "..text)
	end
end

function say_duty()
	if Player[_id].duty == 0 then
		Player[_id].duty = 1
		msg("\169150255150[SERVER]:\169255255255 Player '"..player(_id,"name").."' is now on duty!")
		msg("\169255150150[SERVER]:\169255255255 Do not attack this person, you will be punished if you do so.")
		Player[_id].dutyi1 = image("gfx/yates/lua/abilities/storm.png",0,0,100+_id)
		imagescale(Player[_id].dutyi1,0.4,0.4)
		imagealpha(Player[_id].dutyi1,0.8)
		tween_rotateconstantly(Player[_id].dutyi1,2)
		Player[_id].dutyi2 = image("gfx/yates/lua/abilities/storm.png",0,0,200+_id)
		imagescale(Player[_id].dutyi2,0.4,0.4)
		imagealpha(Player[_id].dutyi2,0.3)
		tween_rotateconstantly(Player[_id].dutyi2,-3)
	elseif Player[_id].duty == 1 then
		Player[_id].duty = 0
		msg("\169150255150[SERVER]:\169255255255 Player '"..player(_id,"name").."' is now off duty!")
		freeimage(Player[_id].dutyi1)
		freeimage(Player[_id].dutyi2)
		Player[_id].dutyi1 = nil
		Player[_id].dutyi2 = nil
	end
end

function say_freeze()
    if checkLevel(_id) > checkLevel(_tbl[2]) then
        if Player[tonumber(_tbl[2])].freeze == 0 then
            msg2(tonumber(_tbl[2]),"\169255150150[SERVER]:\169255255255 You have been frozen. Wait for an admin to unfreeze you.")
            msg2(tonumber(_tbl[2]),"\169255150150[SERVER]:\169255255255 Screaming, capsing, flaming and spamming will only make it worse for you!")
            msg("\169255150150[SERVER]:\169255255255 Player '"..player(_tbl[2],"name").."' has been frozen.")
            parse("speedmod "..tonumber(_tbl[2]).." "..-100)
            Player[tonumber(_tbl[2])].freeze = 1
        elseif Player[tonumber(_tbl[2])].freeze == 1 then
            msg2(tonumber(_tbl[2]),"\169150255150[SERVER]:\169255255255 You have been unfrozen, don't do the same shit that got you frozen.")
            msg("\169150255150[SERVER]:\169255255255 Player '"..player(_tbl[2],"name").."' has been unfrozen.")
            parse("speedmod "..tonumber(_tbl[2]).." "..0)
            Player[tonumber(_tbl[2])].freeze = 0
        end
    else
        msg2(_id,"\169255150150[SERVER]:\169255255255 You have no authorisation over this administration group!")
    end
end

function say_goto()
	parse("setpos ".._id.." "..player(tonumber(_tbl[2]),"x").." "..player(tonumber(_tbl[2]),"y"))
end

function say_bring()
	parse("setpos ".._tbl[2].." "..player(_id,"x").." "..player(_id,"y"))
end

function say_bigears()
    if Player[_id].bigears == 0 then
        Player[_id].bigears = 1
        msg2(_id,"\169150255150[SERVER]:\169255255255 You will now hear all PM's and radius messages (if the server uses it).")
    elseif Player[_id].bigears == 1 then
        Player[_id].bigears = 0
        msg2(_id,"\169150255150[SERVER]:\169255255255 You will no longer hear all PM's and radius messages (if the server uses it).")
    end
end

function say_lastplayers()
    local minutes = _tbl[2] and tonumber(_tbl[2]) or 10 -- Filter out players by login time
    local time = os.time()
    local todisplay = {}
    for k = #lastlogged, 1, -1 do
        local v = lastlogged[k]
        if (v) then
            if (time-v.time <= minutes*60) then
                if ((_tbl[2] and v.id == 0) or (not _tbl[2])) then
                    table.insert(todisplay, v)
                end
            else
                table.remove(lastlogged, k)
            end
        end
    end

    msg2(_id, "\169150255150[SERVER]: Displaying player info from the last "..minutes.." minutes.")

    for k, v in pairs(todisplay) do
        local str = v.name .. " (" .. v.ip .. ", "
        if (v.usgn ~= 0) then str = str .. "USGN #" .. v.usgn .. ")" else str = str .. "no USGN)" end
        local mins = math.floor((time-v.time)/60 + 0.5)
        if (v.id ~= 0) then str = str .. " - online (ID #"..v.id..")" else str = str .. " - last online "..(mins > 0 and mins.." minutes ago" or (time-v.time).." seconds ago") end
        msg2(_id,"\169255255255"..k..". "..str)
    end
end

function say_whois()
    local id = tonumber(_tbl[2])
    if (not id) then msg2(_id, "\169255025000ERROR: No ID specified!") return end
    if (not player(id, "exists")) then msg2(_id, "\169255025000ERROR: No such player exists!") return end

    local ranks = {"Player", "VIP", "Member", "Moderator", "Admin", "Co-Owner", "Owner"}
    local rank = checkLevel(id)
    local iso, cname = geoip:lookup(player(id, "ip"))
    local uname = usgndb:lookup(player(id, "usgn"))
    msg2(_id, "\169255150150[SERVER]: \169255255255Displaying information for "..player(id, "name").." (ID #"..id..")")
    msg2(_id, "\169150255150[SERVER]: \169255255255IP: "..player(id, "ip").." ("..cname..")")
    if (player(id, "usgn") ~= 0) then
        msg2(_id, "\169150255150[SERVER]: \169255255255USGN #"..player(id, "usgn").." ("..uname..")")
    else
        msg2(_id, "\169150255150[SERVER]: \169255255255No USGN login")
    end
    msg2(_id, "\169150255150[SERVER]: \169255255255User rank: "..ranks[rank].." ("..rank..")")
end

function say_notag()
    Player[_id].notag = not Player[_id].notag
    if (Player[_id].notag) then
        msg2(_id, "\169255150150[SERVER]: \169255255255Your messages will now be displayed as a normal player's.")
    else
        msg2(_id, "\169255150150[SERVER]: \169255255255Your messages will now display your user rank.")
    end
end