-- ph_func.lua --

-- Functions
function ph_join(id)
	Player[id] = {}
	Player[id].load = 0
	Player[id].proptime = 0
	Player[id].propgrentime = 0
	Player[id].propname = ""
	Player[id].proptracker = 0
	Player[id].proptrackcount = 0
	Player[id].checkAttack = 0
	Player[id].checkGrenAttack = 0
	Player[id].flash = 0
	Player[id].text = 1
	Player[id].muted = 0
	Player[id].rankname = "Noob"
	Player[id].rank = 0
	Player[id].exp = 0
	Player[id].run = 0
	Player[id].stamina = 100
	Player[id].originalSpeed = 0
	Player[id].streak = 0
	Player[id].money = 0
	Player[id].load = 0
	Player[id].propgren = 3
	Player[id].teamid = 0
	Player[id].die = false
	Player[id].changeteam = true
	Player[id].flash = 0
	Player[id].teamid = 0
	
	--player_details()
	
	timer(1000,"_joinstuff",id)
end

function _joinstuff(id)
	id = tonumber(id)
	
	-- Messages
	msg2(id,"000255000Welcome back '"..player(id,"name").."' (U.S.G.N.: "..player(id,"usgn")..") (IP: "..player(id,"ip")..")")
	msg2(id,"255100000"..game("sv_name").."")
	msg2(id,"255255255!comment <comment> - Leave us a comment/suggestion!")
	msg2(id,"255255255For help say !help, if you need help with commands say !help <command>")
	-- Hudtxt
	parse('hudtxt2 '..id..' 0 "255255255'..game("sv_name")..'" 450 100')
	parse('hudtxt2 '..id..' 1 "255255255'..site..'" 450 116')
end

function ph_leave(id)
	if Player[id].flash == 1 then
		freeimage(Player[id].flashimage)
		Player[id].flashimage = nil
	end
	if Player[id].propimage then
		freeimage(Player[id].propimage)
		Player[id].propimage = nil
	end
	player_details()
end

function ph_startround_prespawn()
	for _,all in pairs(player(0,"table")) do
		timer(100,"parse","setarmor "..all.." 0")
		parse("setweapon "..all.." 50")
	end
end

function ph_startround()
	local colour = 0
	msg(c[3].."The hunt will begin in 10 seconds!@C")
	timer(10000,"parse","lua _releaseHunters()")
end

function ph_endround(mode)
	freetimer("parse", "lua _releaseHunters()")
	roundStart = false
	for _, all in pairs(player(0, "table")) do
		if Player[all].propimage then
			freeimage(Player[all].propimage)
			Player[all].propimage = nil
		end
	end
	if mode == 3 then
		timer(1000, "parse", "msg ..actually the Terrorists (props) won!@C")
	end
end

function ph_team(id,team)
	if team == 0 then
		Player[id].teamid = 0
	end
	if team == 1 or team == 2 then
		-- stuff
	end
end

function ph_spawn(id)
	if player(id,"team") == 1 then
		msg2(id,c[2].." You are a prop, find a prop and press [E] to become it!")
		msg2(id,c[2].." Hunters lose health if they attack and don't hit a prop! Use this to your advantage!")
		timer(100,"parse","strip "..id.." 2")
		timer(100,"parse","setarmor "..id.." 0")
		parse("sethealth "..id.." 30")
		if Player[id].rankimage then
			freeimage(Player[id].rankimage)
			Player[id].rankimage = nil
		end
	else
		msg2(id,c[2].." You are a hunter, find and kill all props!")
		msg2(id,c[2].." Do not attack unless you know it's a prop! You will DIE if you do.")
		timer(100,"parse","equip "..id.." 24")
		timer(100,"parse","strip "..id.." 1")
		if roundStart == true then
			parse("setpos "..id.." "..(phspawn[game("sv_map")][1]*32+16).." "..(phspawn[game("sv_map")][2]*32+16))
		end
	end
end

function ph_die(id)
	Player[id].proptime = 0
	Player[id].propgren = 2
	Player[id].propgrentime = 0
	if Player[id].propimage then
		freeimage(Player[id].propimage)
		Player[id].propimage = nil
	end
	if Player[id].die == false then
		local color = 0
		if player(id,"team") == 1 then
			colour = "\169255025000"
			Player[id].teamid = 1
		elseif player(id,"team") == 2 then
			colour = "\169050150255"
			Player[id].teamid = 2
		end
		msg(colour..""..player(id,"name")..""..c[3].." has died.")
	end
end

function ph_kill(killer,victim)

end

function ph_hit(id,source,weapon)
	if player(source,"team") == 1 then
		return 1
	else
		if player(id,"team") == 1 then
			if weapon == 24 or weapon == 50 then
				Player[source].checkAttack = 1
				if player(id,"health") > 5 then
					parse("sethealth "..id.." "..player(id,"health")-5)
					return 1
				end
			elseif weapon == 47 then
				Player[source].checkGrenAttack = 1
			end
		end
	end
end

function ph_attack(id)
	if player(id,"team") == 2 then
		timer(50,"_checkAttack",id)
	end
end

function ph_attack2(id)
	if player(id,"team") == 2 then
		if player(id,"weapontype") == 50 then
			timer(50,"_checkAttack",id)
		end
	end
end

function ph_select(id,type,mode)
	if type ~= 24 or type ~= 50 then
		return 1
	end
end

function ph_drop(id)
	return 1
end

function ph_walkover(id)
	return 1
end

function ph_use(id)
	if player(id,"health") > 0 then
		if player(id,"team") == 1 then
			if entity(player(id,"tilex"),player(id,"tiley"),"exists") and entity(player(id,"tilex"),player(id,"tiley"),"type") == 22 then
				if Player[id].proptime == 0 then
					local imagepath = entity(player(id,"tilex"),player(id,"tiley"),"str0")
					tbl_ = imagepath:split('/')
					for all = 1, #tbl_ do
						if string.sub(tbl_[all],-4,-1) == ".bmp" or string.sub(tbl_[all],-4,-1) == ".PNG" then
							imagename = tbl_[all]:split('%.')
							Player[id].newimage = 1
							break
						end
					end
					if Player[id].newimage == 1 then
						Player[id].newimage = 0
						if _checkImage(imagename[1]) then
							parse("setarmor "..id.." 206")
							Player[id].propname = ""..imagename[1].."."..imagename[2]..""
							msg2(id,c[2].." Congratulations, you have changed prop. Hide!")
							if Player[id].propimage then
								freeimage(Player[id].propimage)
								Player[id].propimage = nil
							end
							Player[id].propimage = image("gfx/yates/ph_/"..imagename[1].."."..imagename[2],1,-1,100+id)
							for all = 1, #phimages[game("sv_map")] do
								if imagename[1] == phimages[game("sv_map")][all][1] then
									Player[id].originalSpeed = phimages[game("sv_map")][all][3]
									parse("sethealth "..id.." "..phimages[game("sv_map")][all][2])
									parse("speedmod "..id.." "..Player[id].originalSpeed)
								end
							end
							Player[id].proptime = 30
						else
							msg2(id,c[1].." This prop is not allowed on this map!")
						end
					end
				else
					msg2(id,c[1].."You have to wait "..Player[id].proptime.." seconds to become a new prop!")
				end
			end
		else
			if player(id,"weapontype") == 24 then
				if Player[id].propgrentime == 0 then
					if Player[id].propgren > 0 then
						reqcld(id,2)
						Player[id].propgren = Player[id].propgren - 1
						Player[id].propgrentime = 8
					else
						msg2(id,c[1].." You do not have any grenades left!")
					end
				else
					msg2(id,c[1].." You have to wait "..Player[id].propgrentime.." seconds to use another grenade!")
				end
			end
		end
	end
end

function ph_clientdata(id,mode,data1,data2)
	if mode == 2 then
		local dist = distance(player(id,"x"),player(id,"y"),data1,data2)
		parse("spawnprojectile "..id.." 47 "..player(id,"x").." "..player(id,"y").." "..dist.." "..player(id,"rot"))
		timer(math.floor(dist*2.8),"_checkGrenade",id)
	end
end

function ph_second()
	if hudtxt_colour == 0 then
	else
		if hudtxt_colourfade == 0 then
			parse("hudtxtcolorfade 0 1 1000 "..hudtxt_colour1.."")
			hudtxt_colourfade = 1
		elseif hudtxt_colourfade == 1 then
			parse("hudtxtcolorfade 0 1 1000 "..hudtxt_colour2.."")
			hudtxt_colourfade = 0
		end
	end

	for _,all in pairs(player(0,"table")) do
		if player(all,"team") ~= 0 then
			if player(all,"health") > 0 then
				if Player[all].proptime > 0 then
					Player[all].proptime = Player[all].proptime - 1
					if Player[all].proptime == 0 then
						msg2(all,c[2].." Your prop cooldown has ended, you may now become another prop!")
					end
				end
				if Player[all].propgrentime > 0 then
					Player[all].propgrentime = Player[all].propgrentime - 1
					if Player[all].propgrentime == 0 then
						msg2(all,c[2].." Your grenade cooldown has ended, you may now use another grenade!")
					end
				end
			end
		end
	end
end

-- Global functions

function _releaseHunters()
	roundStart = true
	msg(c[3].."The hunters have been released!@C")
	for _, all in pairs(player(0, "table")) do
		if player(all, "team") == 2 then
			parse("setpos "..all.." "..(phspawn[game("sv_map")][1]*32+16).." "..(phspawn[game("sv_map")][2]*32+16))
		end
	end
end

function _checkImage(iname)
    for all = 1, #phimages[game("sv_map")] do
        if iname == phimages[game("sv_map")][all][1] then
			return true
		end
    end
    return false
end

function _checkAttack(id)
	id = tonumber(id)
	
	if Player[id].checkAttack ~= 1 then
		if roundStart == true then
			parse("sethealth "..id.." "..player(id,"health")-5)
			msg2(id,c[1].." You didn't hit a prop! Don't attack unless you are sure you will hit something!")
		end
	else
		Player[id].checkAttack = 0
	end
end

function _checkGrenade(id)
	id = tonumber(id)
	
	if Player[id].checkGrenAttack ~= 1 then
		if roundStart == true then
			parse("sethealth "..id.." "..player(id,"health")-5)
			msg2(id,c[1].." You didn't hit a prop! Don't attack unless you are sure you will hit something!")
		end
	else
		Player[id].checkGrenAttack = 0
	end
end

function _checkFlash(id)
	id = tonumber(id)
	
	if Player[id].flash == 1 then
		tween_alpha(Player[id].flashimage,2500,0)
		timer(2500,"freeimage",Player[id].flashimage)
		timer(2500,"parse","lua Player["..id.."].flash=0")
	end
end

function _fakeProp(id)
	if Player[id].fakepropimage then
		freeimage(Player[id].fakepropimage)
		Player[id].fakepropimage = nil
	end
	Player[id].fakepropimage = image("gfx/yates/ph_/"..Player[id].propname,0,0,0)
	imagepos(Player[id].fakepropimage,player(id,"x"),player(id,"y"),math.random(1,360))
end

function distance(x1,y1,x2,y2)
    return math.floor(math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)))
end

function table.max(t)
	local a, b
	for k, v in pairs(t) do
		if (not a or not b or v > b) and type(v) == "number" then
			a = k
			b = v
		end
	end
	return a, b
end

function string:split(delimiter)
    local result = { }
    local from  = 1
    local delim_from, delim_to = string.find( self, delimiter, from  )
    while delim_from do
        table.insert( result, string.sub( self, from , delim_from-1 ) )
        from  = delim_to + 1
        delim_from, delim_to = string.find( self, delimiter, from  )
    end
    table.insert( result, string.sub( self, from  ) )
    return result
end