-- ph_server.lua --

-- Dofiles
dofile("sys/lua/prophunt/ph_admin.lua")
dofile("sys/lua/prophunt/ph_func.lua")
dofile("/home/ftpuser/cs2d/reroute_details.lua")

-- Hooks
addhook("join","ph_join")
addhook("leave","ph_leave")
addhook("startround","ph_startround")
addhook("startround_prespawn","ph_startround_prespawn")
addhook("endround","ph_endround")
addhook("team","ph_team")
addhook("spawn","ph_spawn")
addhook("die","ph_die")
addhook("kill","ph_kill")
addhook("hit","ph_hit")
addhook("attack","ph_attack")
addhook("attack2","ph_attack2")
addhook("select","ph_select")
addhook("drop","ph_drop")
addhook("walkover","ph_walkover")
addhook("use","ph_use")
addhook("clientdata","ph_clientdata")
addhook("second","ph_second")

-- Lua Settings
Player = {}

sn = 7
site = "www.theanalbagels.eu"

hudtxt_colour = 1
hudtxt_colourfade = 0
hudtxt_colour1 = "255 0 0"
hudtxt_colour2 = "255 255 0"

minute_info = 0
roundStart = 0

phspawn = {
	["ph_deadcity_v1"] = {10, 46}
}

phimages = {
    ["ph_deadcity_v1"] = {
		{"axe",10,3},
		{"cue",10,3},
		{"apples",15,0},
		{"barbeque",5,5},
		{"basketball_by_ilzeproductions-d3bgh1i",15,3},
		{"book",10,3},
		{"brick04",25,0},
		{"Brownchair",40,-5},
		{"can01",5,5},
		{"carrot",15,0},
		{"chair",25,-3},
		{"coins",20,0},
		{"Creamchair",40,-5},
		{"Creamcouch",80,-8},
		{"dagger",10,3},
		{"gas",15,0},
		{"grains",15,0},
		{"greenbottle",10,3},
		{"key",1,8},
		{"money",10,3},
		{"nails",10,3},
		{"sock",10,3},
		{"spam",15,3},
		{"spiderweb",20,0},
		{"streetchair",35,-3},
		{"streetlight",60,-5},
		{"teddy",15,0},
		{"vase",10,3},
		{"Blackchair",40,-5},
		{"Blackcouch",80,-8},
		{"Blackbarchair",40,-5},
		{"bottle",5,5},
		{"bottle2",5,5},
		{"boy",10,3},
		{"under",10,3},
		{"Greenchair",40,-5},
		{"license",10,3},
		{"skull",25,0},
	},
}

c = {
	"\169255150150[SERVER]:\169255255255",
	"\169150255150[SERVER]:\169255255255",
	"\169255255255"
}

-- Server Settings
parse("sv_fow 0")
parse("mp_infammo 1")
parse("mp_autoteambalance 1")
parse("mp_hud 77")
parse("mp_hovertext 28")
parse("sv_gm 0")
parse("mp_roundtime 5")