Monster = {name = 'Monster', health = 100, image = 'gfx/weiwen/circle.png', scalex = 1, scaley = 1, atk = 1, def = 1, spd = 5, x = 0, y = 0, ang = 0, imgang = 0, exp = 5, money = 50, type = 'monster', loot = {}}
MONSTERS = {}
local t = 0

local SPAWNS = {
	TUTSPAWN1 = {{0, 100}, {15, 118}},
	NOOBSPAWN1 = {{30, 35}, {73, 70}},
	NOOBSPAWN2 = {{0, 0}, {30, 65}},
	CAVE1 = {{245, 154}, {299, 185}},
	CAVE2 = {{85, 55}, {125, 80}},
	GRASSLAND1 = {{127, 0}, {199, 70}},
	GRASSLAND2 = {{155, 85}, {199, 145}},
	GRASSLAND3 = {{155, 140}, {199, 199}},
	GRASSLAND4 = {{55, 160}, {150, 199}},
	MONSTER1 = {{266, 29}, {298, 90}},
	MONSTER2 = {{217, 57}, {253, 90}},
    SKELETON1 = {{250, 110}, {295, 145}},
}

Slime = {limit = 0}
Toothroach = {limit = 0}
Weak_Zombie = {limit = 0}
Zombie = {limit = 0}
Zombie_2 = {limit = 0}
Old_Zombie = {limit = 0}
Armoured_Zombie = {limit = 0}
Tail_Runner = {limit = 0}
Invisible_Zombie = {limit = 0}
Tentacle_Zombie = {limit = 0}
Hamster_Maggot = {limit = 0}
Hamster_Titan = {limit = 0}
Arachnazombie = {limit = 0}
Demon_Runner = {limit = 0}
Fat_Demon = {limit = 0}
Rancor = {limit = 0 }
Skeleton = {limit = 0}
Skeleton_Toothroach = {limit = 0}
Skeleton_Runner = {limit = 0}
Skeleton_Spider = {limit = 0}

CONFIG.MONSTERS = {
	{
		name = 'Slime', limit = 3, health = 80, maxhealth = 80, image = 'gfx/yates/RPG/Slime.png', scalex = 1, scaley = 1,
		atk = 0.1, def = 1, spd = 3, atkspd = 5, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {100}},
        size = 16,
		spawn = {
			['rpg_mapb'] = {SPAWNS.TUTSPAWN1}
		}, 
		exp = 2, money = 4, loot = {{chance = 10000, id = 553}},
	}, 
	{
		name = 'Toothroach', limit = 5, health = 70, maxhealth = 70, image = 'gfx/yates/RPG/Toothroach.png', scalex = 1, scaley = 1,
		atk = 0.2, def = 0.8, spd = 15, atkspd = 3, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {90}},
        size = 16,
		spawn = {
			['rpg_mapb'] = {SPAWNS.NOOBSPAWN1}
		}, 
		exp = 2, money = 4, loot = {{chance = 5, id = 550}},
	}, 
	{
		name = 'Weak_Zombie', limit = 9, health = 60, maxhealth = 60, image = 'gfx/yates/RPG/Weak Zombie.png', scalex = 1, scaley = 1,
		atk = 0.8, def = 1.2, spd = 5, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {90}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.NOOBSPAWN1}
		}, 
		exp = 2, money = 9, 
	}, 
	{
		name = 'Zombie', limit = 4, health = 90, maxhealth = 90, image = 'gfx/yates/RPG/Zombie.png', scalex = 1, scaley = 1,
		atk = 1.4, def = 1.5, spd = 7, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.NOOBSPAWN2}
		}, 
		exp = 6, money = 15, 
	}, 
	{
		name = 'Zombie_2', limit = 4, health = 90, maxhealth = 90, image = 'gfx/yates/RPG/Zombie 2.png', scalex = 1, scaley = 1,
		atk = 1.4, def = 1.5, spd = 7, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.NOOBSPAWN2}
		}, 
		exp = 6, money = 15, 
	}, 
	--[[{
		name = 'Skeleton Toothroach', health = 120, maxhealth = 120, image = 'gfx/yates/RPG/Skeleton Roach.png', scalex = 1, scaley = 1, 
		atk = 0.4, def = 1, spd = 15, atkspd = 4, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {70}}, 
		spawn = {
			['rpg_mapb'] = {SPAWNS.SKELETONCAVE1}
		}, 
		exp = 8, money = 8, loot = {{chance = 7000, id = 552}},
	}, 
	{
		name = 'Skeleton', health = 200, maxhealth = 200, image = 'gfx/yates/RPG/Skeleton.png', scalex = 1, scaley = 1, 
		atk = 1.8, def = 1.8, spd = 7, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}}, 
		spawn = {
			['rpg_mapb'] = {SPAWNS.SKELETONCAVE1}
		}, 
		exp = 22, money = 15, loot = {{chance = 7000, id = 552}},
	}, 
	{
		name = 'Skeleton Runner', health = 300, maxhealth = 300, image = 'gfx/yates/RPG/Skeleton Runner.png', scalex = 1, scaley = 1, 
		atk = 2.2, def = 2.5, spd = 22, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {40}}, 
		spawn = {
			['rpg_mapb'] = {SPAWNS.SKELETONCAVE1}
		}, 
		exp = 54, money = 44, loot = {{chance = 7000, id = 552}},
	},]]
	{
		name = 'Old_Zombie', limit = 6, health = 150, maxhealth = 150, image = 'gfx/yates/RPG/Old Zombie.png', scalex = 1, scaley = 1,
		atk = 2, def = 1.8, spd = 7, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {75}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.CAVE1}
		}, 
		exp = 13, money = 17, loot = {{chance = 10, id = 559}},
	}, 
	{
		name = 'Armoured_Zombie', limit = 6, health = 120, maxhealth = 120, image = 'gfx/yates/RPG/Armoured Zombie.png', scalex = 1, scaley = 1,
		atk = 1.8, def = 3, spd = 8, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {75}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.CAVE1}
		}, 
		exp = 16, money = 18,
	},
	{
		name = 'Tail_Runner', limit = 3, health = 300, maxhealth = 300, image = 'gfx/yates/RPG/Tail Runner.png', scalex = 1, scaley = 1,
		atk = 2.2, def = 2, spd = 22, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {50}},
        size = 48,
		spawn = {
			['rpg_mapb'] = {SPAWNS.CAVE2}
		}, 
		exp = 38, money = 44, loot = {{chance = 10, id = 557}},
	},
	{
		name = 'Invisible_Zombie', limit = 6, health = 200, maxhealth = 200, image = 'gfx/yates/RPG/Invisible Zombie.png', scalex = 1, scaley = 1,
		atk = 2.5, def = 2.5, spd = 8, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.GRASSLAND1}
		}, 
		exp = 30, money = 24, loot = {{chance = 10, id = 556}},
	},
	{
		name = 'Tentacle_Zombie', limit = 5, health = 200, maxhealth = 200, image = 'gfx/yates/RPG/Tentacle Zombie.png', scalex = 1, scaley = 1,
		atk = 2.2, def = 3, spd = 10, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.GRASSLAND1}
		}, 
		exp = 36, money = 31, loot = {{chance = 10, id = 558}},
		spc = {500, function(self, id, dist) 
			if dist <= 128 then
				radiusmsg("\169255150150[COMBAT]:\169255255255 Tentacle Zombie uses tentacle whip!", self.x, self.y)
				self:hit(id, 20)
			end
		end},
	},
	{
		name = 'Hamster_Maggot', limit = 4, health = 500, maxhealth = 500, image = 'gfx/yates/RPG/Hamster Maggot.png', scalex = 1, scaley = 1,
		atk = 3, def = 5, spd = 8, atkspd = 3, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {35}},
        size = 48,
		spawn = {
			['rpg_mapb'] = {SPAWNS.MONSTER1}
		}, 
		exp = 80, money = 150, 
		spc = {150, function(self, id, dist) 
			if dist <= 32 then
				if not self.explode then
					radiusmsg("\169255150150[COMBAT]:\169255255255 Hamster Maggot is going to explode!", self.x, self.y)
					self._spd = self.spd
					self.spd = 1
					self.explode = true
					tween_color(self.image,3000, 255, 100, 100)
					local proj1 = math.random(1,120)
					local proj2 = math.random(121,240)
					local proj3 = math.random(241,360)
					timer(3100,"parse","spawnprojectile 0 47 "..self.x.." "..self.y.." 256 "..proj1)
					timer(3100,"parse","spawnprojectile 0 47 "..self.x.." "..self.y.." 256 "..proj2)
					timer(3100,"parse","spawnprojectile 0 47 "..self.x.." "..self.y.." 256 "..proj3)
					timer(3100, "CONFIG.MONSTERSKILLS.endExplode", self.id)
				end
			end
		end},
	},
	{
		name = 'Hamster_Titan', limit = 1, health = 800, maxhealth = 800, image = 'gfx/yates/RPG/Hamster Titan.png', scalex = 1, scaley = 1,
		atk = 3.5, def = 5, spd = 12, atkspd = 5, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {15}},
        size = 64,
		spawn = {
			['rpg_mapb'] = {SPAWNS.MONSTER1}
		}, 
		exp = 120, money = 400, 
		spc = {500, function(self, id, dist) 
			if dist <= 96 then
				radiusmsg("\169255150150[COMBAT]:\169255255255 Hamster Titan uses hammer!", self.x, self.y)
				self:hit(id, 100)
			end
		end},
	},
	{
		name = 'Arachnazombie', limit = 5, health = 500, maxhealth = 500, image = 'gfx/yates/RPG/Arachnazombie.png', scalex = 1, scaley = 1,
		atk = 3, def = 4, spd = 10, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {50}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.GRASSLAND2}
		}, 
		exp = 52, money = 35, loot = {{chance = 10, id = 559}},
	},
	{
		name = 'Demon_Runner', limit = 2, health = 600, maxhealth = 600, image = 'gfx/yates/RPG/Demon Runner.png', scalex = 1, scaley = 1,
		atk = 2.4, def = 3, spd = 22, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {30}},
        size = 48,
		spawn = {
			['rpg_mapb'] = {SPAWNS.GRASSLAND3}
		}, 
		exp = 78, money = 46, 
	},
	{
		name = 'Fat_Demon', limit = 5, health = 375, maxhealth = 375, image = 'gfx/yates/RPG/Fat Demon.png', scalex = 1, scaley = 1,
		atk = 3.1, def = 5.1, spd = 9, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {45}},
        size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.GRASSLAND4}
		}, 
		exp = 58, money = 38, 
	},
    {
        name = 'Skeleton_Toothroach', limit = 2, health = 120, maxhealth = 120, image = 'gfx/yates/RPG/Skeleton Roach.png', scalex = 1, scaley = 1,
        atk = 0.4, def = 1, spd = 15, atkspd = 4, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {70}},
        size = 16,
        spawn = {
            ['rpg_mapb'] = {SPAWNS.SKELETON1}
        },
        exp = 8, money = 8, loot = {{chance = 33, id = 552}},
    },
    {
        name = 'Skeleton', health = 200, limit = 5, maxhealth = 200, image = 'gfx/yates/RPG/Skeleton.png', scalex = 1, scaley = 1,
        atk = 1.8, def = 1.8, spd = 7, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {80}},
        size = 32,
        spawn = {
            ['rpg_mapb'] = {SPAWNS.SKELETON1}
        },
        exp = 22, money = 15, loot = {{chance = 50, id = 552}},
    },
    {
        name = 'Skeleton_Runner', health = 300, limit = 2, maxhealth = 300, image = 'gfx/yates/RPG/Skeleton Runner.png', scalex = 1, scaley = 1,
        atk = 2.2, def = 2.5, spd = 22, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {40}},
        size = 48,
        spawn = {
            ['rpg_mapb'] = {SPAWNS.SKELETON1}
        },
        exp = 54, money = 44, loot = {{chance = 80, id = 552}},
    },
    {
        name = 'Skeleton_Spider', health = 500, limit = 1, maxhealth = 500, image = 'gfx/yates/RPG/Skeleton Spider.png', scalex = 1, scaley = 1,
        atk = 3, def = 3, spd = 8, atkspd = 4, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {40}},
        size = 48,
        spawn = {
            ['rpg_mapb'] = {SPAWNS.SKELETON1}
        },
        exp = 54, money = 72, loot = {{chance = 80, id = 552}},
    },
    --[[{
        name = 'Rancor', limit = 0, health = 1000, maxhealth = 1000, image = 'gfx/yates/RPG/Rancor.png', scalex = 1, scaley = 1,
        atk = 4, def = 6, spd = 11, atkspd = 3, x = 0, y = 0, ang = 180, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {0}},
        size = 64,
        spawn = {
            ['rpg_mapb'] = {SPAWNS.MONSTER2}
        },
        exp = 180, money = 220,
    },
    {
        name = 'Charmander', health = 100, image = 'gfx/weiwen/pokemon/4.png', scalex = 2, scaley = 2,
        atk = 2.2, def = 1.8, spd = 6, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {5}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 15, money = 100, loot = {{chance = 5000, id = 100}, {chance = 250, id = 222}},
        spc = {1000, function(self, target)
            radiusmsg("Charmander uses ember!", self.x, self.y)
            parse('explosion ' .. self.x .. ' ' .. self.y .. ' 96 40')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 64 255 128 0')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 96 255 255 0')
        end},
    },
    {
        name = 'Squirtle', health = 100, image = 'gfx/weiwen/pokemon/7.png', scalex = 2, scaley = 2,
        atk = 1.7, def = 2.3, spd = 6, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {5}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 15, money = 100, loot = {{chance = 5000, id = 101}, {chance = 250, id = 223}},
        spc = {1000, function(self)
            radiusmsg("Squirtle uses watergun!", self.x, self.y)
            parse('explosion ' .. self.x .. ' ' .. self.y .. ' 96 40')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 96 255 255 255')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 75 96 128 128 255')
        end},
    },
    {
        name = 'Weedle', health = 100, image = 'gfx/weiwen/pokemon/13.png', scalex = 1.5, scaley = 1.5, r = 104, g = 152, b = 40,
        atk = 1.2, def = 1.1, spd = 7, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 20,
        spawnchance = {['rpg_mapb'] = {100}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 5, money = 30, loot = {{chance = 8000, id = 1}},
    },
    {
        name = 'Pidgey', health = 100, image = 'gfx/weiwen/pokemon/16.png', scalex = 2, scaley = 2,
        atk = 1.2, def = 1.2, spd = 10, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 20,
        spawnchance = {['rpg_mapb'] = {50}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 13, money = 60, loot = {},
        spc = {500, function(self)
            radiusmsg("Pidgey uses sand attack!", self.x, self.y)
            parse('flashposition ' .. self.x .. ' ' .. self.y .. ' 100')
        end},
    },
    {
        name = 'Ratata', health = 100, image = 'gfx/weiwen/pokemon/19.png', scalex = 1.5, scaley = 1.5,
        atk = 1.0, def = 1.0, spd = 9, atkspd = 5, x = 0, y = 0, ang = 0, imgang = 0, runat = 20,
        spawnchance = {['rpg_mapb'] = {100}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 7, money = 50, loot = {{chance = 8000, id = 4}},
    },
    {
        name = 'Spearow', health = 100, image = 'gfx/weiwen/pokemon/21.png', scalex = 2, scaley = 2,
        atk = 1.4, def = 1.0, spd = 10, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 20,
        spawnchance = {['rpg_mapb'] = {50}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 13, money =60, loot = {},
        spc = {2500, function(self, id, dist)
            if not self.agility then
                radiusmsg("Spearow uses agility!", self.x, self.y)
                parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 155 255 155")
                radiussound("weapons/g_flash.wav", self.x, self.y)
                self._spd = self.spd
                self.spd = 10
                self.agility = true
                imagecolor(self.image, 155, 255, 155)
                timer(5000, "CONFIG.MONSTERSKILLS.endAgility", self.id)
            elseif dist <= 32 then
                self:hit(id, 10)
            end
        end},
    },
    {
        name = 'Ekans', health = 100, image = 'gfx/weiwen/pokemon/23.png', scalex = 2, scaley = 2,
        atk = 1.8, def = 1.2, spd = 7, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {20}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 10, money = 80, loot = {},
        spc = {500, function(self, id, dist)
            if dist <= 96 then
                radiusmsg("Ekans uses poison sting!", self.x, self.y)
                self:hit(id, 20)
            end
        end},
    },
    {
        name = 'Pikachu', health = 100, image = 'gfx/weiwen/pokemon/25.png', scalex = 2, scaley = 2,
        atk = 2.1, def = 2.1, spd = 7, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {5}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 25, money = 120, loot = {{chance = 5000, id = 103}, {chance = 250, id = 220}},
        spc = {500, function(self)
            radiusmsg("Pikachu uses thundershock!", self.x, self.y)
            parse('explosion ' .. self.x .. ' ' .. self.y .. ' 96 40')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 96 255 255 0')
            parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 75 64 255 255 255')
        end},
    },
    {
        name = 'Sandshrew', health = 100, image = 'gfx/weiwen/pokemon/27.png', scalex = 2, scaley = 2,
        atk = 1.7, def = 2.1, spd = 7, atkspd = 7, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {5, 20}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF, SPAWNS.ONIXCAVE}
        },
        exp = 18, money = 120, loot = {},
        spc = {1000, function(self)
            radiusmsg("Sandshrew uses sand attack!", self.x, self.y)
            parse('flashposition ' .. self.x .. ' ' .. self.y .. ' 100')
        end},
    },
    {
        name = 'NidoranF', health = 100, image = 'gfx/weiwen/pokemon/29.png', scalex = 2, scaley = 2,
        atk = 1.8, def = 1.2, spd = 7, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {20}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 10, money = 80, loot = {},
        spc = {750, function(self, id, dist)
            if dist <= 96 then
                radiusmsg("NidoranF uses poison sting!", self.x, self.y)
                self:hit(id, 20)
            end
        end},
    },
    {
        name = 'NidoranM', health = 100, image = 'gfx/weiwen/pokemon/32.png', scalex = 2, scaley = 2,
        atk = 1.8, def = 1.2, spd = 7, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10,
        spawnchance = {['rpg_mapb'] = {20}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 10, money = 80, loot = {},
        spc = {750, function(self, id, dist)
            if dist <= 96 then
                radiusmsg("NidoranM uses horn attack!", self.x, self.y)
                self:hit(id, 20)
            end
        end},
    },
    {
        name = 'Vulpix', health = 100, image = 'gfx/weiwen/pokemon/37.png', scalex = 2, scaley = 2,
        atk = 2.2, def = 1.8, spd = 7, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 0,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 10, money = 100, loot = {{chance = 5000, id = 104}},
        spc = {500, function(self, id, dist)
            radiusmsg("Vulpix uses flamethrower!", self.x, self.y)
            local x1, y1 = self.x, self.y
            local rot = math.atan2(player(id, 'y')-y1, player(id, 'x')-x1) + math.pi/2
            local x2, y2 = math.sin(rot), -math.cos(rot)
            local fire = image("gfx/sprites/spot.bmp", 0, 0, 1)
            imagepos(fire, x1+x2*64, y1+y2*64, math.deg(rot)+180)
            imagescale(fire, 1.5, 2)
            imagecolor(fire, 255, 64, 0)
            imageblend(fire, 1)
            timer(500, "freeimage", fire)
            parse('explosion ' .. x1+x2*100 .. ' ' .. y1+y2*100 .. ' 48 40')
            parse('explosion ' .. x1+x2*50 .. ' ' .. y1+y2*50 .. ' 32 40')
        end},
    },
    {
        name = 'Meowth', health = 100, image = 'gfx/weiwen/pokemon/52.png', scalex = 2, scaley = 2,
        atk = 2.2, def = 2.2, spd = 10, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 0,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 25, money = 100, loot = {{chance = 1000, id = 230}},
    },
    {
        name = 'Mankey', health = 100, image = 'gfx/weiwen/pokemon/56.png', scalex = 2, scaley = 2,
        atk = 2.5, def = 1.8, spd = 10, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 0, range = 48,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 25, money = 120, loot = {{chance = 1000, id = 300},{chance = 1000, id = 301},{chance = 1000, id = 302},{chance = 1000, id = 303},{chance = 1000, id = 304},{chance = 1000, id = 305},{chance = 1000, id = 306}},
        spc = {1000, function(self, id, dist)
            if not self.rage then
                radiusmsg("Mankey uses rage!", self.x, self.y)
                parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 255 155 155")
                radiussound("weapons/g_flash.wav", self.x, self.y)
                self._atk = self.atk
                self.atk = 3.3
                self.rage = true
                imagecolor(self.image, 255, 155, 155)
                timer(5000, "CONFIG.MONSTERSKILLS.endRage", self.id)
            elseif dist <= 96 then
                radiusmsg("Mankey uses karate chop!", self.x, self.y)
                self:hit(id, 20)
            end
        end},
    },
    {
        name = 'Abra', health = 100, image = 'gfx/weiwen/pokemon/63.png', scalex = 2, scaley = 2,
        atk = 0.6, def = 1.0, spd = 5, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 100,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.FULLMAP}
        },
        exp = 8, money = 50, loot = {{chance = 5000, id = 105}},
        spc = {2500, function(self)
            radiusmsg("Abra uses teleport!", self.x, self.y)
            parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 255 255 255")
            local dir = math.random(math.pi*2)
            if self:move(dir, 40) or self:move(dir, -40) then
                parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 255 255 255")
            end
        end},
    },
    {
        name = 'Gastly', health = 100, image = 'gfx/weiwen/pokemon/92.png', scalex = 2, scaley = 2, r = 64, g = 0, b = 64,
        atk = 1.2, def = 1.5, spd = 8, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 50,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 8, money = 100, loot = {},
        spc = {1000, function(self, id, dist)
            if dist <= 64 and not PLAYERS[id].tmp.paralyse then
                radiusmsg("Gastly uses lick!", self.x, self.y)
                PLAYERS[id].tmp.paralyse = true
                msg2(id, "You are paralysed.")
                parse("effect \"colorsmoke\" " .. player(id, 'x') .. " " .. player(id, 'y') .. " 5 5 64 0 64")
                timer(3000, "rem.paralyse", id)
            elseif dist <= 32 then
                self:hit(id, 10)
            end
        end},
    },
    {
        name = 'Onix', health = 125, image = 'gfx/weiwen/pokemon/95.png', scalex = 3, scaley = 3, r = 144, g = 144, b = 144,
        atk = 1.8, def = 5.0, spd = 3, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 0, range = 64,
        spawnchance = {['rpg_mapb'] = {5}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.ONIXCAVE}
        },
        exp = 100, money = 300, loot = {{chance = 1000, id = 310},{chance = 1000, id = 311},{chance = 1000, id = 312},{chance = 1000, id = 313},{chance = 1000, id = 314},{chance = 1000, id = 315},{chance = 1000, id = 316}},
        spc = {1000, function(self)
            if not self.harden then
                radiusmsg("Onix uses harden!", self.x, self.y)
                parse("effect \"colorsmoke\" " .. self.x .. " " .. self.y .. " 5 5 192 192 192")
                radiussound("weapons/g_flash.wav", self.x, self.y)
                self._def = self.def
                self.def = 7.5
                self.harden = true
                imagecolor(self.image, 155, 155, 255)
                timer(5000, "CONFIG.MONSTERSKILLS.endHarden", self.id)
            end
        end},
    },
    {
        name = 'Voltorb', health = 100, image = 'gfx/weiwen/pokemon/100.png', scalex = 2, scaley = 2, r = 144, g = 144, b = 144,
        atk = 2.3, def = 2.3, spd = 5, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 20, range = 48,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 30, money = 130, loot = {{chance = 5000, id = 103}},
        spc = {1000, function(self)
            if self.health < 20 then
                radiusmsg("Voltorb uses selfdestruct!", self.x, self.y)
                parse('explosion ' .. self.x .. ' ' .. self.y .. ' 128 80')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 128 255 128 0')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 128 255 255 0')
                self:destroy()
            else
                radiusmsg("Voltorb uses thundershock!", self.x, self.y)
                parse('explosion ' .. self.x .. ' ' .. self.y .. ' 96 40')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 96 255 255 0')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 75 64 255 255 255')
            end
        end},
    },
    {
        name = 'Koffing', health = 100, image = 'gfx/weiwen/pokemon/109.png', scalex = 2, scaley = 2, r = 128, g = 128, b = 0,
        atk = 2.0, def = 1.7, spd = 4, atkspd = 10, x = 0, y = 0, ang = 0, imgang = 0, runat = 20, range = 48,
        spawnchance = {['rpg_mapb'] = {10}},
        spawn = {
            ['rpg_mapb'] = {SPAWNS.BOTTOMHALF}
        },
        exp = 30, money = 150, loot = {{chance = 5000, id = 106}},
        spc = {1000, function(self)
            if self.health < 20 then
                radiusmsg("Koffing uses explosion!", self.x, self.y)
                parse('explosion ' .. self.x .. ' ' .. self.y .. ' 128 40')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 128 255 128 0')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 128 255 255 0')
                self:destroy()
            else
                radiusmsg("Koffing uses poison fog!", self.x, self.y)
                parse('explosion ' .. self.x .. ' ' .. self.y .. ' 96 40')
                parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 100 96 128 128 0')
            end
        end},
    }, ]]
}

CONFIG.MONSTERSKILLS = {
	endExplode = function(id)
		self = MONSTERS[tonumber(id)]
		self.spd = self._spd
		self._spd = nil
		imagecolor(self.image, 255, 255, 255)
		self.explode = nil
		self:die()
	end,
}

addhook("attack", "MONSTERattack")
function MONSTERattack(id)
	if gettile(PLAYERS[id].x, PLAYERS[id].y).SAFE or gettile(PLAYERS[id].x, PLAYERS[id].y).NOMONSTERS then
		return
	end
	if inarray({400, 401, 402, 403, 404, 405, 406}, PLAYERS[id].Equipment[7]) then
		msg2(id,"\169255150150[SERVER]:\169255255255 You are not allowed to attack on a horse.")
		return
	end
	local weapon, closest = player(id, 'weapontype')
	for _, m in ipairs(MONSTERS) do
		local x, y = player(id, 'x'), player(id, 'y')
		local dist = math.sqrt((m.x-x)^2+(m.y-y)^2)
		if dist <= (closest and closest[2] or (CONFIG.WEAPONRANGE[weapon] or CONFIG.WEAPONRANGE[50])) then
			local rot = player(id, 'rot')
			if math.abs(math.rad(rot) - math.atan2(y-m.y, x-m.x) + math.pi/2)%(2*math.pi) <= (CONFIG.WEAPONWIDTH[weapon] or CONFIG.WEAPONRANGE[50]) then
				if free_line(player(id,"x"),player(id,"y"),m.x,m.y) then
					--msg(string.char(169).."000255000Yes, the path from your character to your monster is clear.")
					closest = {m, dist}
				else
					--msg(string.char(169).."255000000No, the path from your character to your monster is not clear.")
				end
			end
		end
	end
	if closest then
		closest[1]:damage(id, math.ceil(20*((PLAYERS[id].Level+50)*PLAYERS[id].tmp.atk/closest[1].def)/math.random(60, 140)), weapon)
		PLAYERS[id].HTimer = 5
	end
end

addhook("ms100", "MONSTERms100")
function MONSTERms100()
	t = t + 1
	if t % 100 == 0 then
		while #MONSTERS < CONFIG.MAXMONSTERS do
			local rand, spawnNo, mapName
			while true do
				rand = math.random(#CONFIG.MONSTERS)
				mapName = CONFIG.MONSTERS[rand].spawn[map'name'] and map'name' or CONFIG.DEFAULTMAP
				spawnNo = math.random(#CONFIG.MONSTERS[rand].spawn[mapName])
				if math.random(0, 100) < CONFIG.MONSTERS[rand].spawnchance[mapName][spawnNo] then
					break
				end
			end
			local m = deepcopy(CONFIG.MONSTERS[rand])
			local x, y, tilex, tiley
			local spawn = m.spawn[mapName][spawnNo]
			if _G[m.name].limit < m.limit then
				_G[m.name].limit = _G[m.name].limit + 1
				repeat
					tilex, tiley = math.random(spawn[1][1], spawn[2][1]), math.random(spawn[1][2], spawn[2][2])
				until not gettile(tilex, tiley).SAFE and
                not gettile(tilex, tiley).NOMONSTERS and
                tile(tilex, tiley, "walkable") and
                tile(tilex, tiley, "frame") ~= 34
				m.x, m.y = math.floor(tilex*32+16), math.floor(tiley*32+16)
				Monster:new(m)
			end
		end
	end
	for _, m in ipairs(MONSTERS) do
		if t % m.atkspd == 0 then
			m.target = nil
			local closest
			for _, p in ipairs(table.shuffle(player(0, 'table'))) do
				if player(p, 'health') > 0 and not gettile(PLAYERS[p].x, PLAYERS[p].y).SAFE and not gettile(PLAYERS[p].x, PLAYERS[p].y).NOMONSTERS then
					local dist = math.sqrt((player(p, 'x')-m.x)^2 + (player(p, 'y')-m.y)^2)
					if Player[p].repel == 1 or Player[p].invunerable == 1 then
						if dist > 128 then
							if not closest or dist < closest[2] then
								closest = {p, dist}
							end
						end
					else
						if dist < 400 then
							if not closest or dist < closest[2] then
								closest = {p, dist}
							end
						end
					end
				end
			end
			if closest then
				local dist = closest[2]
				if dist < 400 then
					m.target = closest[1]
					if m.spc and math.random(10000) <= m.spc[1] then
						m.spc[2](m, m.target, dist)
					elseif dist <= (m.range or 32) then
						m:hit(m.target, 10)
						PLAYERS[m.target].HTimer = 5
					end
				end
			end
		end
		if m.target and player(m.target, 'exists') and player(m.target, 'health') > 0 and
			not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).SAFE and
			not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).NOMONSTERS then
			xdist, ydist = player(m.target, 'x') - m.x, player(m.target, 'y') - m.y
			local dist = math.sqrt(xdist^2 + ydist^2)
			if dist < 400 then
				m.ang = math.atan2(ydist, xdist)-math.pi/2+math.random(-1, 1)/2
			else
				m.target = nil
			end
		end
		if not m.target then
			m:rot(math.random(-1, 1)/2)
		end
		m.imgang = math.deg(m.ang)
		if not m:move(m:rot(), m.health > m.runat and 1 or -1) then
			repeat until m:move(math.rad(math.random(360)), 1)
		end
	end
end

function Monster:new(m)
	if not (m.x or m.y) then return false end
	m.image = image(m.image, m.x, m.y, 0)
	imagescale(m.image, m.scalex, m.scaley)
	setmetatable(m, self)
	self.__index = self
	local n = #MONSTERS+1
	MONSTERS[#MONSTERS+1] = m
	m.id = n
	return m
end

function Monster:pos(x, y)
	if not x and not y then
		return self.x, self.y
    else
        if not occupied(x,y,self.id) then
		    self.x, self.y = x or self.x, y or self.y
        end
		for all = 1, 17 do
			if player(all,"exists") and player(all,"health") > 0 then
				if player(all,"x") >= self.x-800 and player(all,"x") <= self.x+800 and player(all,"y") >= self.y-800 and player(all,"y") <= self.y+800 then
                    imagepos(self.image, self.x, self.y, self.imgang)
                    imagealpha(self.image, 1)
                    break
				end
			end
			if all == 17 then
				imagealpha(self.image, 0)
			end
		end
	end
	return true
end

function Monster:move(dir, amt,monsterid) --this function just gives true or false, but not coordinates, nor monster ID, right? yep, just checks
    local x, y = -math.sin(dir)*amt*self.spd, math.cos(dir)*amt*self.spd
    local x, y = self.x+x, self.y+y
    local tilex, tiley = math.floor(x/32), math.floor(y/32)
    if tile(tilex, tiley, 'walkable') and tile(tilex, tiley, 'frame') ~= 34 and
            not gettile(tilex, tiley).SAFE and
            not gettile(tilex, tiley).NOMONSTERS  then
        self:pos(x, y)
        return true
    else
        self:rot(math.random(-1, 1)*math.pi/2)
        return false
    end
end

function occupied(x,y,monsterid)
    for n, m in pairs (MONSTERS) do
        if monsterid ~= n and math.sqrt(math.pow(math.abs(m.x-x),2) + math.pow(math.abs(m.y-y),2)) <= m.size then
            return true
        end
    end
    return false
end

function Monster:damage(id, dmg, wpntype)
	if not PLAYERS[id].Tutorial.damagem then
        msg2(id,"\169150255150[SERVER]:\169255255255 You've attacked a monster (mob). Keep hitting it until it dies!")
		PLAYERS[id].Tutorial.damagem = true
	end
	local wpnName
	if wpntype == 251 then
		wpnName = 'rune'
	elseif wpntype == 46 then
		wpnName = 'firewave'
		dmg = dmg/5
	else
		wpnName = PLAYERS[id].Equipment[3] and ITEMS[PLAYERS[id].Equipment[3]].name or 'dagger'
		if wpnName == "Machete [35]" then
			local chance = math.random(1,15)
			if chance == 1 then
				local dmgchance = math.random(1,dmg)
				msg2(id,"\169150255150[COMBAT]:\169255255255 You have set the mob alight, "..dmgchance.." extra damage!")
				parse('effect "fire" '..self.x..' '..self.y..' 30 30')
				dmg = dmg + dmgchance
			end
		elseif wpnName == "Machete [55]" then
			local chance = math.random(1,10)
			if chance == 1 then
				local dmgchance = math.random(1,dmg)
				msg2(id,"\169150255150[COMBAT]:\169255255255 You have set the mob alight, "..dmgchance.." extra damage!")
				parse('effect "fire" '..self.x..' '..self.y..' 50 50')
				dmg = dmg + dmgchance
			end
		elseif wpnName == "Ancient Battleaxe [65]" then
			local chance = math.random(1,20)
			if chance == 1 then
				msg2(id,"\169150255150[COMBAT]:\169255255255 Lucky bastard, you have dealt double damage!")
				Player[id].battleaxei1 = image("gfx/yates/RPG/wave.png",0,0,100+id)
				imagescale(Player[id].battleaxei1,0.1,0.1)
				imageblend(Player[id].battleaxei1,1)
				imagealpha(Player[id].battleaxei1,0.2)
				imagecolor(Player[id].battleaxei1,250,0,0)
				tween_scale(Player[id].battleaxei1,200,50,50)
				timer(150,"freeimage",Player[id].battleaxei1)
                timer(150,"parse","lua "..Player[id].battleaxei1.."=nil")
				dmg = dmg * 2
			end
		elseif wpnName == "Ancient Battleaxe [90]" then
			local chance = math.random(1,15)
			if chance == 1 then
				msg2(id,"\169150255150[COMBAT]:\169255255255 Lucky bastard, you have dealt TRIPLE damage!")
				Player[id].battleaxei1 = image("gfx/yates/RPG/wave.png",0,0,100+id)
				imagescale(Player[id].battleaxei1,0.1,0.1)
				imageblend(Player[id].battleaxei1,1)
				imagealpha(Player[id].battleaxei1,0.3)
				imagecolor(Player[id].battleaxei1,250,0,0)
				tween_scale(Player[id].battleaxei1,200,50,50)
				timer(150,"freeimage",Player[id].battleaxei1)
                timer(150,"parse","lua "..Player[id].battleaxei1.."=nil")
				dmg = dmg * 3
			end
		end
	end
	self.health = self.health - dmg
	if self.health < 0 then
		self.health = 0
	end
	hudtxt2(id,30,''..self.name..'', '255150150',470,424,0)
	hudtxt2(id,31,'Damage dealt: '..dmg..'', '150150150',470,439,0)
	hudtxt2(id,32,'Monster health: '..self.health..'/'..self.maxhealth..'', '150150150',470,454,0)
	freetimer("parse","hudtxtalphafade "..id.." 30 500 0")
	freetimer("parse","hudtxtalphafade "..id.." 31 500 0")
	freetimer("parse","hudtxtalphafade "..id.." 32 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 30 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 31 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 32 500 0")
	if self.health <= 0 then
		if not PLAYERS[id].Tutorial.killm then
            msg2(id,"\169150255150[SERVER]:\169255255255 Congratulations! You have killed your first monster. You can proceed to pick up the loot by pressing G.")
			PLAYERS[id].Tutorial.killm = true
		end
		if self.name == "Toothroach" then
			if PLAYERS[id].q1 == 1 then
				PLAYERS[id].q1m = PLAYERS[id].q1m + 1
				freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
				if PLAYERS[id].q1m ~= 5 then
					hudtxt2(id,41,'\169000255000Toothroach: '..PLAYERS[id].q1m..'/5', '255255255',320,391,1)
					timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
				elseif PLAYERS[id].q1m == 5 then
					hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Bart and finish the quest.', '255255255',320,391,1)
					timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
					PLAYERS[id].q1 = 2
				end
			elseif PLAYERS[id].q1 == 2 then
				hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Bart and finish the quest.', '255255255',320,391,1)
				timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
			end
        end
        if self.name == "Tail_Runner" then
            if PLAYERS[id].q2 == 1 then
                PLAYERS[id].q2m = PLAYERS[id].q2m + 1
                freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
                if PLAYERS[id].q2m ~= 10 then
                    hudtxt2(id,41,'\169000255000Tail Runner: '..PLAYERS[id].q2m..'/10', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                elseif PLAYERS[id].q2m == 10 then
                    hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Roman and finish the quest.', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                    PLAYERS[id].q2 = 2
                end
            elseif PLAYERS[id].q2 == 2 then
                hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Roman and finish the quest.', '255255255',320,391,1)
                timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
            end
        end
        if self.name == "Arachnazombie" then
            if PLAYERS[id].q3 == 1 then
                PLAYERS[id].q3m = PLAYERS[id].q3m + 1
                freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
                if PLAYERS[id].q3m ~= 50 then
                    hudtxt2(id,41,'\169000255000Arachnazombie: '..PLAYERS[id].q3m..'/50', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                elseif PLAYERS[id].q3m == 50 then
                    hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Peeta and finish the quest.', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                    PLAYERS[id].q3 = 2
                end
            elseif PLAYERS[id].q3 == 2 then
                hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Peeta and finish the quest.', '255255255',320,391,1)
                timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
            end
        end
        if self.name == "Demon_Runner" then
            if PLAYERS[id].q4 == 1 then
                PLAYERS[id].q4m = PLAYERS[id].q4m + 1
                freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
                if PLAYERS[id].q4m ~= 25 then
                    hudtxt2(id,41,'\169000255000Demon Runner: '..PLAYERS[id].q4m..'/25', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                elseif PLAYERS[id].q4m == 25 then
                    hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mark and finish the quest.', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                    PLAYERS[id].q4 = 2
                end
            elseif PLAYERS[id].q4 == 2 then
                hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mark and finish the quest.', '255255255',320,391,1)
                timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
            end
        end
        if self.name == "Skeleton" then
            if PLAYERS[id].q5 == 1 then
                PLAYERS[id].q5m = PLAYERS[id].q5m + 1
                freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
                if PLAYERS[id].q5m ~= 100 then
                    hudtxt2(id,41,'\169000255000Skeleton: '..PLAYERS[id].q5m..'/100', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                elseif PLAYERS[id].q5m == 100 then
                    hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mahn and finish the quest.', '255255255',320,391,1)
                    timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
                    PLAYERS[id].q5 = 2
                end
            elseif PLAYERS[id].q5 == 2 then
                hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mahn and finish the quest.', '255255255',320,391,1)
                timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
            end
        end
		if PLAYERS[id].tmp.party[1] ~= 0 then
			local teamp = 0
			local pexp = 0
			for i = 1, 4 do
				if player(PLAYERS[id].tmp.party[i],"exists") then
					teamp = teamp + 1
				end
				if i == 4 then
					for all = 1, 4 do
						if player(PLAYERS[id].tmp.party[all],"exists") then
							pexp = math.floor(self.exp*CONFIG.EXPRATE/teamp)
							addexp(PLAYERS[id].tmp.party[all],pexp)
							msg2(PLAYERS[id].tmp.party[all],"\169150255255[EXP]:\169255255255 "..player(id,"name").." has gained you "..pexp.." experience.")
						end
					end
				end
			end
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(1,120))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(121,240))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(241,360))
			self:die()
        else
            if Player[id].p_mastery == 2 then
                pexp = math.floor(self.exp*CONFIG.EXPRATE)
                addexp(id,pexp*1.10)
                msg2(id,"\169150255255[EXP]:\169255255255 You have gained "..pexp.." experience (+"..math.floor((self.exp*CONFIG.EXPRATE*0.10))..").")
            else
                pexp = math.floor(self.exp*CONFIG.EXPRATE)
                addexp(id,pexp)
                msg2(id,"\169150255255[EXP]:\169255255255 You have gained "..pexp.." experience.")
            end
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(1,120))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(121,240))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(241,360))
			self:die()
		end
	else
		parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 0 ' .. self.scaley .. ' ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	end
	radiussound("weapons/machete_hit.wav", self.x, self.y)
	return true
end

function Monster:hit(id, dmg)
    dmg = math.floor(tonumber(dmg))
	if not PLAYERS[id].Tutorial.hitm then
        msg2(id,"\169255150150[SERVER]:\169255255255 A monster is attacking you! You can fight back by swinging your weapon at it (left click).")
		PLAYERS[id].Tutorial.hitm = true
    end
    EXPhit(id, self, -1, dmg)
	radiussound("weapons/knife_hit.wav", self.x, self.y)
	return true
end

function Monster:die(id)
	local size = self.scalex+self.scaley
	parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' ' .. size .. ' 64 ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	local tilex, tiley = math.floor(self.x/32), math.floor(self.y/32)
	spawnitem(1337, tilex, tiley, math.floor(self.money*math.random(50, 150)/100)*CONFIG.MONEYRATE)
	for _, loot in ipairs(self.loot) do
		local chance = math.random(100)
		if chance <= loot.chance then
			spawnitem(loot.id, tilex, tiley)
		end
	end
	_G[self.name].limit = _G[self.name].limit - 1
	radiussound("weapons/c4_explode.wav", self.x, self.y)
	self:destroy()
end

function Monster:destroy()
	freeimage(self.image)
	local found
	table.remove(MONSTERS, self.id)
	for i, m in ipairs(MONSTERS) do
		m.id = i
	end
	return true
end

function Monster:rot(rot)
	if not rot then
		return self.ang
	else
		self.ang = (self.ang+rot)%(math.pi*2)
	end
	return true
end